; Des_Spirales.scm
; Download : 
;
;	Copyright (C) 2013 samj ( http://www.aljacom.com/ )
;
;	Licence GPL
;		Ce fichier est le Script-Fu "Des_Spirales.scm" pour Gimp. 
;		Ce Script-Fu "Des_Spirales.scm" est un logiciel libre ; vous pouvez le redistribuer ou le modifier suivant les termes de la GNU General Public License
;		telle que publie par la Free Software Foundation ; soit la version 3 de la licence, soit ( votre gr) toute version ultrieure.
;		Ce Script-Fu "Des_Spirales.scm" est distribu dans l'espoir qu'il sera utile, mais SANS AUCUNE GARANTIE ; 
;		pas mme la garantie implicite de COMMERCIABILISABILIT ni d'ADQUATION  UN OBJECTIF PARTICULIER.
;		Consultez la GNU General Public License pour plus de dtails.
;		Vous devez avoir reu une copie de la GNU General Public License en mme temps que GIMP ; si ce n'est pas le cas, consultez <http://www.gnu.org/licenses>
;
;	Ce fichier Des_Spirales.scm est dit avec Notepad++    http://notepad-plus-plus.org/
;
;
;
;
;
;
;	Version 0.1 du 20130529 pour tests, uniquement spirale d'Archimde et spirale logarithmique.
;
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;
;
;	Chaque spirale est sauvegard sous forme de chemin. Les cercles sont aussi sauvegards sous forme de chemin.
;	Each spiral is saved as a path. Circles are also saved as path
;
;
;	Accs par :
;
;	Fichier > Filtres > Rendu > Spirals / Spirales ...
;	File > Filters > Render > Spirals / Spirales ...
;
;
;
;
;
;
;
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;
;
; Inspiration :
;			http://fr.wikipedia.org/wiki/Spirale_d'Archim%C3%A8de
;			http://www.mathcurve.com/courbes2d/archimede/archimede.shtml
;			http://en.wikipedia.org/wiki/Archimedean_spiral
;			http://fr.wikipedia.org/wiki/Spirale_logarithmique
;			http://www.mathcurve.com/courbes2d/logarithmic/logarithmic.shtml
;			http://en.wikipedia.org/wiki/Logarithmic_spiral
;			http://www.mathcurve.com/courbes2d/logarithmic/spiraledor.shtml
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;
;
;

		
(define	
	(
		Spirals_Spirales_samj
		image
		drawable
		X_origine_pourcent
		Y_origine_pourcent
		Nombre_de_spirales
		Type_de_spirale
		Sens_de_Rotation
		Angle_de_depart
		Coefficient_Expansion
		Nombre_de_tours
		Echantillons_par_tour
		Rayon_Minimum
		Inscrire_dans_un_cercle
		Color_Pencil_1
		Pencil_1_Line_Thickness
		Color_intensity


		
	)
	(let* 
		(

			(message (car (gimp-message-get-handler)))

			(2pi (* 2 3.14159265358979323846) )

			(Nom_de_la_brosse "Ma_Brosse_Spirale_samj")
			(The_shape_of_the_generated_brush 0) ; "Circle" "Square" "Diamond"
			(rayon_brosse (/ Pencil_1_Line_Thickness 2) )
			(sortie_boucle_tracer 0)


			(width (car (gimp-image-width image)))
			(height (car (gimp-image-height image)))

			(transparence (car (gimp-drawable-has-alpha drawable)))



			(X_origine_pixels (* 0.01 width X_origine_pourcent) )
			(Y_origine_pixels (* 0.01 height Y_origine_pourcent) )
			(sortie_boucle 0)
			(nombre_de_boucle 0)
			(increment_angle 0)
			(angle_en_cours 0)


			(chemin_spirale)
			(Points_chemin_spirale)
			(Ajout_Points_chemin_spirale)
			(Nombre_Points_chemin_spirale 0)

			(X_1 0)
			(Y_1 0)
			(X_total_spirale 0)
			(Y_total_spirale 0)
			(trigonometrique_horaire 0)

			(angle_entre_spirales (/ 2pi Nombre_de_spirales) )
			(sortie_boucle_nombre_de_spirales 0)
			(Nombre_boucles_de_spirales 0)
			(Angle_de_depart_calcule 0)
			(rayon_inscrire 0)


			(inclinaison_1 1)



		)


		; (set! Type_de_spirale 1)


		; pour image existante
		(gimp-undo-push-group-start image) 
		
		;; Start undo. Recommand par Saulgoode pour nouvelle image http://gimpchat.com/viewtopic.php?f=9&t=7342#p93780
		; (gimp-image-undo-disable image)

		; sauvegard le contexte.  Recommand par Saulgoode http://gimpchat.com/viewtopic.php?f=9&t=7342#p93780
		(gimp-context-push)

		;; slectionner la console erreurs pour envoyer un message
		(gimp-message-set-handler 2)		


;******************************************************************************************************
; 
;******************************************************************************************************

		; (gimp-message (string-append "X_origine_pixels : " (number->string X_origine_pixels) " Y_origine_pixels : " (number->string Y_origine_pixels) ) )	

		(gimp-context-set-foreground Color_Pencil_1)

		; crer une brosse
		(gimp-brush-new Nom_de_la_brosse)				

		(gimp-context-set-brush-size rayon_brosse )
		;;;(gimp-context-set-brush-default-size)
		(gimp-context-set-brush-aspect-ratio 1)
		(gimp-context-set-brush-angle 0)
		
		(gimp-context-set-brush Nom_de_la_brosse)

		(gimp-brush-set-shape Nom_de_la_brosse The_shape_of_the_generated_brush) ; forme

		(gimp-brush-set-radius Nom_de_la_brosse rayon_brosse ) ; rayon

		(gimp-brush-set-spikes Nom_de_la_brosse 2) ; pointes
		(gimp-brush-set-hardness Nom_de_la_brosse 1.0) ; duret 
		(gimp-brush-set-aspect-ratio Nom_de_la_brosse 1 ) ; proportions
		(gimp-brush-set-angle Nom_de_la_brosse 0) ; angle
		(gimp-brush-set-spacing Nom_de_la_brosse 1.0 ) ; espacement





;******************************************************************************************************
; Archimedian Spiral / Spirale d Archimde
;******************************************************************************************************

		(if (= Type_de_spirale 0)
			(begin

				(set! Coefficient_Expansion (* Coefficient_Expansion 2)  ) ; pour avoir une certaine correspondance entre les types de spirales


				;transformation degrs radians
				(set! Angle_de_depart (* (/ 2pi 360) Angle_de_depart) )

				(set! increment_angle (/ 2pi Echantillons_par_tour )  )

				; slectionner brosse
				(gimp-context-set-brush Nom_de_la_brosse)

				(set! sortie_boucle_nombre_de_spirales 0)
				(set! Nombre_boucles_de_spirales -1)

				(if (= Inscrire_dans_un_cercle 1) ; "The Largest Possible Circle / Le plus grand cercle possible"
					(begin
						(set! rayon_inscrire  (min X_origine_pixels Y_origine_pixels (- width X_origine_pixels) (- height Y_origine_pixels) )     )

						(if (< rayon_inscrire Rayon_Minimum) ; il n'y a rien  tracer
							(begin
								(set! Nombre_de_spirales 0 ) ; pour sortie automatique sans tracer de spirale
							)
						)
					)
				)


				(while (= sortie_boucle_nombre_de_spirales 0)
					(begin

						(set! Nombre_de_spirales (- Nombre_de_spirales 1) )
						(set! Nombre_boucles_de_spirales (+ Nombre_boucles_de_spirales 1) )

						(if (< Nombre_de_spirales 0)
							(begin
								(set! sortie_boucle_nombre_de_spirales 1)
							)
							;else
							(begin


								(set! nombre_de_boucle 0)
								(set! sortie_boucle 0)

								(set! Angle_de_depart_calcule (+ Angle_de_depart (* Nombre_boucles_de_spirales angle_entre_spirales )  )  )
								(set! angle_en_cours (- 0 increment_angle )  )


								(while (= sortie_boucle 0)
									(begin

										(set! nombre_de_boucle (+ nombre_de_boucle 1 ) )

										; conditions de sortie
										(if (> nombre_de_boucle 8260) (set! sortie_boucle 1 ) )	; Pour ventuellement crer des chemins par sommets de polygone. Chemins fonctionnent avec  8280 , ne fonctionne pas avec 8370

										(set! angle_en_cours (+ angle_en_cours increment_angle )  )

										; conditions de sortie
										(if (> angle_en_cours (* 2pi Nombre_de_tours)  )   (set! sortie_boucle 1 )   )


										; Archimedian Spiral / Spirale d Archimde
										(if (= Sens_de_Rotation 0)
											(begin
												; sens trigonometrique
												(set! X_1  (* Coefficient_Expansion  (* angle_en_cours (sin (+ angle_en_cours Angle_de_depart_calcule) ) ) )   )
												(set! Y_1  (* Coefficient_Expansion  (* angle_en_cours (cos (+ angle_en_cours Angle_de_depart_calcule) ) ) )   )										
												
											)
											;else
											(begin
												; sens horaire
												(set! X_1  (* Coefficient_Expansion  (* angle_en_cours (cos (+ angle_en_cours Angle_de_depart_calcule) ) ) )   )
												(set! Y_1  (* Coefficient_Expansion  (* angle_en_cours (sin (+ angle_en_cours Angle_de_depart_calcule) ) ) )   )
											)
										)


										(if (= Inscrire_dans_un_cercle 1) ; "The Largest Possible Circle / Le plus grand cercle possible"
											(begin
												(if (> (sqrt (+ (* X_1 X_1) (* Y_1 Y_1) ) ) rayon_inscrire) ; tout est trac
													(begin
														(set! sortie_boucle 1 ) ; pour sortir du trac de la spirale
													)
												)
											)
										)


										(if (< (sqrt (+ (* X_1 X_1) (* Y_1 Y_1) ) )   Rayon_Minimum )
											(begin
												(set! nombre_de_boucle (- nombre_de_boucle 1 ) )
												
											)
											;else
											(begin

												(set! X_total_spirale (+ X_origine_pixels  X_1)  )
												(set! Y_total_spirale (+ Y_origine_pixels  Y_1)  )

												; conditions de sortie
												(if (<  X_total_spirale 0) (set! sortie_boucle 1 ) )
												(if (>  X_total_spirale width) (set! sortie_boucle 1 ) )
												(if (<  Y_total_spirale 0) (set! sortie_boucle 1 ) )
												(if (>  Y_total_spirale height) (set! sortie_boucle 1 ) )

												(if (= sortie_boucle 0)
													(begin
														(if (= nombre_de_boucle 1)
															(begin
																(set! Points_chemin_spirale (list X_total_spirale Y_total_spirale X_total_spirale Y_total_spirale X_total_spirale Y_total_spirale ) )
																(set! Nombre_Points_chemin_spirale 6 )
															)
															;else
															(begin
																(set! Ajout_Points_chemin_spirale (list X_total_spirale Y_total_spirale X_total_spirale Y_total_spirale X_total_spirale Y_total_spirale ) )
																(set! Points_chemin_spirale (append Points_chemin_spirale Ajout_Points_chemin_spirale) )
																(set! Nombre_Points_chemin_spirale (+ 6 Nombre_Points_chemin_spirale ) )
															)
														)
													)
												)


											)
										)


									)
								)

								; (gimp-message (string-append "nombre_de_boucle : " (number->string nombre_de_boucle)   ) )

								(set! chemin_spirale (car (gimp-vectors-new image (strcat "Archimedian_Spiral_" (number->string nombre_de_boucle) "_"  (number->string Sens_de_Rotation) "_"  (number->string Nombre_boucles_de_spirales)    )   ) )  ) 
								(gimp-image-insert-vectors image chemin_spirale 0 -1)

								(gimp-vectors-stroke-new-from-points
									chemin_spirale
									0
									Nombre_Points_chemin_spirale
									(list->vector Points_chemin_spirale )
									0
								)

								(set! sortie_boucle_tracer Color_intensity)

								(while (> sortie_boucle_tracer 0)
									(begin
										(gimp-edit-stroke-vectors drawable (car (gimp-image-get-active-vectors image) ) )
										(set! sortie_boucle_tracer (- sortie_boucle_tracer 1) )
									)
								)


							)
						)

					)
				)

			)
		)









;******************************************************************************************************
; Logarithmic Spiral / Spirale logarithmique
;******************************************************************************************************

		(if (= Type_de_spirale 1)
			(begin

				(set! Coefficient_Expansion (* Coefficient_Expansion 0.08)  ) ; pour avoir une certaine correspondance entre les types de spirales

				;transformation degrs radians
				(set! Angle_de_depart (* (/ 2pi 360) Angle_de_depart) )

				(set! increment_angle (/ 2pi Echantillons_par_tour )  )

				(if (= Sens_de_Rotation 0)
					(begin
						; sens trigonometrique
						(set! trigonometrique_horaire -1)
					)
					;else
					(begin
						; sens horaire
						(set! trigonometrique_horaire 1)				
					)
				)

				; slectionner brosse
				(gimp-context-set-brush Nom_de_la_brosse)

				(set! sortie_boucle_nombre_de_spirales 0)
				(set! Nombre_boucles_de_spirales -1)

				(if (= Inscrire_dans_un_cercle 1) ; "The Largest Possible Circle / Le plus grand cercle possible"
					(begin
						(set! rayon_inscrire  (min X_origine_pixels Y_origine_pixels (- width X_origine_pixels) (- height Y_origine_pixels) )     )

						(if (< rayon_inscrire Rayon_Minimum) ; il n'y a rien  tracer
							(begin
								(set! Nombre_de_spirales 0 ) ; pour sortie automatique sans tracer de spirale
							)
						)
					)
				)


				(while (= sortie_boucle_nombre_de_spirales 0)
					(begin

						(set! Nombre_de_spirales (- Nombre_de_spirales 1) )
						(set! Nombre_boucles_de_spirales (+ Nombre_boucles_de_spirales 1) )

						(if (< Nombre_de_spirales 0)
							(begin
								(set! sortie_boucle_nombre_de_spirales 1)
							)
							;else
							(begin


								(set! nombre_de_boucle 0)
								(set! sortie_boucle 0)

								(set! Angle_de_depart_calcule (+ Angle_de_depart (* Nombre_boucles_de_spirales angle_entre_spirales )  )  )
								(set! angle_en_cours (- 0 (+ increment_angle Angle_de_depart_calcule ) ) )


								(while (= sortie_boucle 0)
									(begin

										(set! nombre_de_boucle (+ nombre_de_boucle 1 ) )

										; conditions de sortie
										(if (> nombre_de_boucle 8260) (set! sortie_boucle 1 ) )	; Pour ventuellement crer des chemins par sommets de polygone. Chemins fonctionnent avec  8280 , ne fonctionne pas avec 8370

										(set! angle_en_cours (+ angle_en_cours increment_angle )  )

										; conditions de sortie
										(if (> angle_en_cours (* 2pi Nombre_de_tours)  )   (set! sortie_boucle 1 )   )

										(set! X_1  (* (exp (* Coefficient_Expansion (+ Angle_de_depart_calcule angle_en_cours) ))  (cos (* trigonometrique_horaire angle_en_cours ) ) )   )
										(set! Y_1  (* (exp (* Coefficient_Expansion (+ Angle_de_depart_calcule angle_en_cours) ))  (sin (* trigonometrique_horaire angle_en_cours ) ) )   )

										(if (= Inscrire_dans_un_cercle 1) ; "The Largest Possible Circle / Le plus grand cercle possible"
											(begin
												(if (> (sqrt (+ (* X_1 X_1) (* Y_1 Y_1) ) ) rayon_inscrire) ; tout est trac
													(begin
														(set! sortie_boucle 1 ) ; pour sortir du trac de la spirale
													)
												)
											)
										)


										(if (< (sqrt (+ (* X_1 X_1) (* Y_1 Y_1) ) )   Rayon_Minimum )
											(begin
												(set! nombre_de_boucle (- nombre_de_boucle 1 ) )
												
											)
											;else
											(begin

												(set! X_total_spirale (+ X_origine_pixels  X_1)  )
												(set! Y_total_spirale (+ Y_origine_pixels  Y_1)  )

												; conditions de sortie
												(if (<  X_total_spirale 0) (set! sortie_boucle 1 ) )
												(if (>  X_total_spirale width) (set! sortie_boucle 1 ) )
												(if (<  Y_total_spirale 0) (set! sortie_boucle 1 ) )
												(if (>  Y_total_spirale height) (set! sortie_boucle 1 ) )

												(if (= sortie_boucle 0)
													(begin
														(if (= nombre_de_boucle 1)
															(begin
																(set! Points_chemin_spirale (list X_total_spirale Y_total_spirale X_total_spirale Y_total_spirale X_total_spirale Y_total_spirale ) )
																(set! Nombre_Points_chemin_spirale 6 )
															)
															;else
															(begin
																(set! Ajout_Points_chemin_spirale (list X_total_spirale Y_total_spirale X_total_spirale Y_total_spirale X_total_spirale Y_total_spirale ) )
																(set! Points_chemin_spirale (append Points_chemin_spirale Ajout_Points_chemin_spirale) )
																(set! Nombre_Points_chemin_spirale (+ 6 Nombre_Points_chemin_spirale ) )
															)
														)
													)
												)


											)
										)


									)
								)

								; (gimp-message (string-append "nombre_de_boucle : " (number->string nombre_de_boucle)   ) )

								(set! chemin_spirale (car (gimp-vectors-new image (strcat "Logarithmic_Spiral_" (number->string nombre_de_boucle) "_"  (number->string Sens_de_Rotation) "_"  (number->string Nombre_boucles_de_spirales)    )   ) )  ) 
								(gimp-image-insert-vectors image chemin_spirale 0 -1)

								(gimp-vectors-stroke-new-from-points
									chemin_spirale
									0
									Nombre_Points_chemin_spirale
									(list->vector Points_chemin_spirale )
									0
								)

								(set! sortie_boucle_tracer Color_intensity)

								(while (> sortie_boucle_tracer 0)
									(begin
										(gimp-edit-stroke-vectors drawable (car (gimp-image-get-active-vectors image) ) )
										(set! sortie_boucle_tracer (- sortie_boucle_tracer 1) )
									)
								)


							)
						)

					)
				)

			)
		)















;******************************************************************************************************
; TEST  partir de :   Archimedian Spiral / Spirale d Archimde
;******************************************************************************************************

		(if (= Type_de_spirale 2)
			(begin

				(set! Coefficient_Expansion (* Coefficient_Expansion 2)  ) ; pour avoir une certaine correspondance entre les types de spirales


				;transformation degrs radians
				(set! Angle_de_depart (* (/ 2pi 360) Angle_de_depart) )

				(set! increment_angle (/ 2pi Echantillons_par_tour )  )

				; slectionner brosse
				(gimp-context-set-brush Nom_de_la_brosse)

				(set! sortie_boucle_nombre_de_spirales 0)
				(set! Nombre_boucles_de_spirales -1)

				(if (= Inscrire_dans_un_cercle 1) ; "The Largest Possible Circle / Le plus grand cercle possible"
					(begin
						(set! rayon_inscrire  (min X_origine_pixels Y_origine_pixels (- width X_origine_pixels) (- height Y_origine_pixels) )     )

						(if (< rayon_inscrire Rayon_Minimum) ; il n'y a rien  tracer
							(begin
								(set! Nombre_de_spirales 0 ) ; pour sortie automatique sans tracer de spirale
							)
						)
					)
				)


				(while (= sortie_boucle_nombre_de_spirales 0)
					(begin

						(set! Nombre_de_spirales (- Nombre_de_spirales 1) )
						(set! Nombre_boucles_de_spirales (+ Nombre_boucles_de_spirales 1) )

						(if (< Nombre_de_spirales 0)
							(begin
								(set! sortie_boucle_nombre_de_spirales 1)
							)
							;else
							(begin


								(set! nombre_de_boucle 0)
								(set! sortie_boucle 0)

								(set! angle_en_cours (- 0 increment_angle )  )
								(set! Angle_de_depart_calcule (+ Angle_de_depart (* Nombre_boucles_de_spirales angle_entre_spirales )  )  )

								(while (= sortie_boucle 0)
									(begin

										(set! nombre_de_boucle (+ nombre_de_boucle 1 ) )

										; conditions de sortie
										(if (> nombre_de_boucle 8260) (set! sortie_boucle 1 ) )	; Pour ventuellement crer des chemins par sommets de polygone. Chemins fonctionnent avec  8280 , ne fonctionne pas avec 8370

										(set! angle_en_cours (+ angle_en_cours increment_angle )  )

										; conditions de sortie
										(if (> angle_en_cours (* 2pi Nombre_de_tours)  )   (set! sortie_boucle 1 )   )


										; pour inclinaison voir si ajouter des paramtres de saisie (inclinaison_1 ...)
										(if (= Sens_de_Rotation 0)
											(begin
												; sens trigonometrique
												(set! X_1  (+ (* Coefficient_Expansion  (* angle_en_cours (sin (+ angle_en_cours Angle_de_depart_calcule) ) ) ) (* inclinaison_1 angle_en_cours (cos (+ angle_en_cours Angle_de_depart_calcule) ) )  )   )
												(set! Y_1  (+ (* Coefficient_Expansion  (* angle_en_cours (cos (+ angle_en_cours Angle_de_depart_calcule) ) ) ) (* inclinaison_1 angle_en_cours (sin (+ angle_en_cours Angle_de_depart_calcule) ) )  )   )
										
												
											)
											;else
											(begin
												; sens horaire
												(set! X_1  (+ (* Coefficient_Expansion  (* angle_en_cours (cos (+ angle_en_cours Angle_de_depart_calcule) ) ) ) (* inclinaison_1 angle_en_cours (sin (+ angle_en_cours Angle_de_depart_calcule) ) )  )   )
												(set! Y_1  (+ (* Coefficient_Expansion  (* angle_en_cours (sin (+ angle_en_cours Angle_de_depart_calcule) ) ) ) (* inclinaison_1 angle_en_cours (cos (+ angle_en_cours Angle_de_depart_calcule) ) )  )   )
											)
										)


										(if (= Inscrire_dans_un_cercle 1) ; "The Largest Possible Circle / Le plus grand cercle possible"
											(begin
												(if (> (sqrt (+ (* X_1 X_1) (* Y_1 Y_1) ) ) rayon_inscrire) ; tout est trac
													(begin
														(set! sortie_boucle 1 ) ; pour sortir du trac de la spirale
													)
												)
											)
										)


										(if (< (sqrt (+ (* X_1 X_1) (* Y_1 Y_1) ) )   Rayon_Minimum )
											(begin
												(set! nombre_de_boucle (- nombre_de_boucle 1 ) )
												
											)
											;else
											(begin

												(set! X_total_spirale (+ X_origine_pixels  X_1)  )
												(set! Y_total_spirale (+ Y_origine_pixels  Y_1)  )

												; conditions de sortie
												(if (<  X_total_spirale 0) (set! sortie_boucle 1 ) )
												(if (>  X_total_spirale width) (set! sortie_boucle 1 ) )
												(if (<  Y_total_spirale 0) (set! sortie_boucle 1 ) )
												(if (>  Y_total_spirale height) (set! sortie_boucle 1 ) )

												(if (= sortie_boucle 0)
													(begin
														(if (= nombre_de_boucle 1)
															(begin
																(set! Points_chemin_spirale (list X_total_spirale Y_total_spirale X_total_spirale Y_total_spirale X_total_spirale Y_total_spirale ) )
																(set! Nombre_Points_chemin_spirale 6 )
															)
															;else
															(begin
																(set! Ajout_Points_chemin_spirale (list X_total_spirale Y_total_spirale X_total_spirale Y_total_spirale X_total_spirale Y_total_spirale ) )
																(set! Points_chemin_spirale (append Points_chemin_spirale Ajout_Points_chemin_spirale) )
																(set! Nombre_Points_chemin_spirale (+ 6 Nombre_Points_chemin_spirale ) )
															)
														)
													)
												)


											)
										)


									)
								)

								; (gimp-message (string-append "nombre_de_boucle : " (number->string nombre_de_boucle)   ) )

								(set! chemin_spirale (car (gimp-vectors-new image (strcat "Test_Spiral_" (number->string nombre_de_boucle) "_"  (number->string Sens_de_Rotation) "_"  (number->string Nombre_boucles_de_spirales)    )   ) )  ) 
								(gimp-image-insert-vectors image chemin_spirale 0 -1)

								(gimp-vectors-stroke-new-from-points
									chemin_spirale
									0
									Nombre_Points_chemin_spirale
									(list->vector Points_chemin_spirale )
									0
								)

								(set! sortie_boucle_tracer Color_intensity)

								(while (> sortie_boucle_tracer 0)
									(begin
										(gimp-edit-stroke-vectors drawable (car (gimp-image-get-active-vectors image) ) )
										(set! sortie_boucle_tracer (- sortie_boucle_tracer 1) )
									)
								)


							)
						)

					)
				)

			)
		)









;******************************************************************************************************
; Crer les chemins des cercles
;******************************************************************************************************

		(if (> Rayon_Minimum 0)
			(begin
				(gimp-image-select-ellipse image 2 (- X_origine_pixels Rayon_Minimum)  (- Y_origine_pixels Rayon_Minimum) (+ Rayon_Minimum Rayon_Minimum) (+ Rayon_Minimum Rayon_Minimum)  )

				; slection vers chemin
				(plug-in-sel2path 1 image drawable)

				; ne rien slectionner
				(gimp-selection-none image)

				(gimp-item-set-name (car (gimp-image-get-active-vectors image) ) "Minimum_Radius" )
			)
		)



		(if (= Inscrire_dans_un_cercle 1) ; "The Largest Possible Circle / Le plus grand cercle possible"
			(begin
				(if (> rayon_inscrire 1)
					(begin
						(gimp-image-select-ellipse image 2 (- X_origine_pixels rayon_inscrire)  (- Y_origine_pixels rayon_inscrire) (+ rayon_inscrire rayon_inscrire) (+ rayon_inscrire rayon_inscrire)  )

						; slection vers chemin
						(plug-in-sel2path 1 image drawable)

						; ne rien slectionner
						(gimp-selection-none image)

						(gimp-item-set-name (car (gimp-image-get-active-vectors image) ) "Inscribed_Within_A_Circle" )
					)
				)

			)
		)



;******************************************************************************************************
; 
;******************************************************************************************************




		(gimp-brush-delete Nom_de_la_brosse)


;******************************************************************************************************
; 
;******************************************************************************************************

		;; rtablir le mode message
		(gimp-message-set-handler message)

		; restituer l'ancien contexte.  Recommand par Saulgoode http://gimpchat.com/viewtopic.php?f=9&t=7342#p93780
		(gimp-context-pop)

		; End undo. Recommand par Saulgoode pour nouvelle image http://gimpchat.com/viewtopic.php?f=9&t=7342#p93780
		;(gimp-image-undo-enable image)

		; pour image existante
		(gimp-undo-push-group-end image)

		(gimp-displays-flush)

	)
)





; Nouvelle mthode recommand par Saulgoode http://gimpchat.com/viewtopic.php?f=9&t=7342#p93780
(script-fu-register "Spirals_Spirales_samj"
                    _"Spirals / Spirales ..."
                    "Spirals / Spirales ..."
                    "samj"
                    "samj"
                    "20130414"
                    "*"
                    SF-IMAGE    "Image"     0
                    SF-DRAWABLE "Drawable"  0
					SF-ADJUSTMENT "X origin % " '(50 0 100 1 5 4 1)
					SF-ADJUSTMENT "Y origin % " '(50 0 100 1 5 4 1)
					SF-ADJUSTMENT "Number of spirals / Nombre de spirales " '(1 1 16 1 5 0 1)
					SF-OPTION "Spiral Type / Type de spirale " '("Archimedian Spiral / Spirale d Archimede" "Logarithmic Spiral / Spirale logarithmique" "Test") 
					SF-OPTION "Rotation " '("Counterclockwise / Sens trigonometrique" "Clockwise / Sens horaire")
					SF-ADJUSTMENT "Departure Angle / Angle de depart " '(0 0 360 1 5 4 1)
					SF-ADJUSTMENT "Coefficient Expansion " '(1 0.02 1000 0.1 0.5 4 1)
					SF-ADJUSTMENT "Tours / Turns " '(10 1 200 1 2 0 1)
					SF-ADJUSTMENT "Samples Per Revolution / Echantillons par tour " '(90 3 180 1 2 0 1)
					SF-ADJUSTMENT "Minimum Radius / Rayon Minimum " '(0 0 200 1 2 0 1)
					SF-OPTION "Inscribed Within A Circle / Inscrire dans un cercle " '("No / Non" "The Largest Possible Circle / Le plus grand cercle possible (> Minimum Radius)")
					SF-COLOR "Color Pencil 1 " '(0 0 0)
					SF-ADJUSTMENT "Pencil 1 - Line Thickness " '(2 1 40 1 5 0 1)
					SF-ADJUSTMENT "Color intensity " '(3 1 10 1 5 0 1)
				


)

; Nouvelle mthode recommand par Saulgoode http://gimpchat.com/viewtopic.php?f=9&t=7342#p93780
(script-fu-menu-register "Spirals_Spirales_samj"
					_"<Image>/Filters/Render"
)




;; FIN





