; Dbut du script-fu Motif_Spirale_Gimp_2_8.scm
;
; Accs par :   Fichier > Crer > Motifs > Motif spirale...
;               File > Create > Patterns > Motif spirale...
;
;                __________________________________________________________
; 
;
;
;
; Licence GNU/GPL
;
; --------------------------------------------------------------------
; dit avec Notepad++    http://notepad-plus-plus.org/
;
; version 1.0 par samj (  http://www.aljacom.com/~gimp       http://samjcreations.blogspot.com  ) 27 juin 2012
;
; --------------------------------------------------------------------
;


(define (
				Motif_Spirale_samj
				Dimension_du_motif
				Nombre_de_spires
				Spirale_dans_le_sens_horaire
				Couleur_1_fond_spirale
				Couleur_2_fond_spirale
				Epaisseur_du_trait_1
				Couleur_du_trait_1
				Epaisseur_du_trait_2
				Couleur_du_trait_2
				Rendre_raccordable
				Aplatir

		)
		
	(let*
		(
			; affectation des variables		
	
			; mmoriser les couleurs PP et AP
			(old-fg (car (gimp-context-get-foreground)))
			(old-bg (car (gimp-context-get-background)))
			
			; mmoriser la brosse active
			(old-brush (car (gimp-context-get-brush)))	

			; mmoriser le dgrad actif
			(old_gradient (car (gimp-context-get-gradient)))

			; dimensions de l'image pour crer la spirale
			(width (round (* Dimension_du_motif (sqrt 2))))
			(height (round (* Dimension_du_motif (sqrt 2))))

			; image qui servira  crer le motif
			(img (car (gimp-image-new width height 0)))		
			
			; calque_fond
			(calque_fond)

			; calque_trait_1
			(calque_trait_1)			
			
			; calque_trait_2
			(calque_trait_2)

			; calque_motif
			(calque_motif)
			
			
		)




		

	
	;; Start undo group.
	(gimp-image-undo-group-start img)			
		
		
; calque_fond*********************************************************************************
	

	; crer calque_fond
	(set! calque_fond (car (gimp-layer-new img width height 1 "calque_fond" 100 0)))	
	
	; ajouter le calque calque_fond
	(gimp-image-insert-layer img calque_fond 0 -1)

	; modifier couleur de premier plan
	(gimp-context-set-foreground '(0 0 0))
	
	; modifier couleur d'arrire plan
	(gimp-context-set-background '(255 255 255))

	; remplir de AP	
	(gimp-drawable-fill calque_fond 1)		

	; dfinir le contexte feather et antialias
	(gimp-context-set-feather FALSE)
	
	(gimp-context-set-feather-radius 
		0									; feather-radius-x 
		0									; feather-radius-y
	)
	
	(gimp-context-set-antialias FALSE)
	
	; slection elliptique pour crer un demi-cercle
	(gimp-image-select-ellipse 
		img									; image 
		0									; operation 
		0									; x 
		(round (/ height 2))				; y 
		(- width 1)							; width 
		(- height 1)						; height
	)
	
	; remplir la slection de PP	
	(gimp-edit-fill calque_fond 0)	
	
	; ne rien slectionner
	(gimp-selection-none img)
	
	; Tourner et aspirer
	(plug-in-whirl-pinch 
		1								; run-mode 
		img								; image 
		calque_fond						; drawable 
		(* 360 (+ Nombre_de_spires 1))	; whirl 
		0								; pinch 
		2								; radius
	)
	
	; retourner le calque si la spirale n'est pas dans le sens horaire
	(if
		(= Spirale_dans_le_sens_horaire FALSE)
			(gimp-item-transform-flip-simple 
				calque_fond		; item 
				0				; flip-type 
				TRUE			; auto-center 
				(/ width 2)		; axis
			)
	)

	; slectionner le noir
	(gimp-image-select-color 
		img								; image 
		0								; operation 
		calque_fond						; drawable 
		'(0 0 0)						; color
	)
	

	; sauvegarder cette slection dans un chemin
	(plug-in-sel2path 1 img calque_fond)
	
	; donner un nom au chemin
	(gimp-item-set-name (car (gimp-image-get-active-vectors img)) "spirale_origine")
	
	; ne rien slectionner
	(gimp-selection-none img)
	
	; dfinir le contexte feather et antialias
	(gimp-context-set-feather TRUE)
	; (gimp-context-set-feather FALSE)
	
	(gimp-context-set-feather-radius 
		(round (+ 1 (/ Dimension_du_motif 100)))	; feather-radius-x 
		(round (+ 1 (/ Dimension_du_motif 100)))	; feather-radius-y
	)
	
	(gimp-context-set-antialias TRUE)	
	
	; slectionner le noir
	(gimp-image-select-color 
		img								; image 
		0								; operation 
		calque_fond						; drawable 
		'(0 0 0)						; color
	)
	
	; modifier couleur de premier plan
	(gimp-context-set-foreground Couleur_1_fond_spirale)
	
	; modifier couleur d'arrire plan
	(gimp-context-set-background Couleur_2_fond_spirale)
	
	; remplir le calque de Couleur_1_fond_spirale
	(gimp-drawable-fill calque_fond 0)

	; inverser la slection
	(gimp-selection-invert img)

	; modifier couleur de premier plan
	(gimp-context-set-foreground Couleur_2_fond_spirale)
	
	; remplir la slection de Couleur_2_fond_spirale
	(gimp-edit-fill calque_fond 0)	

	; ne rien slectionner
	(gimp-selection-none img)

	; slectionner Couleur_1_fond_spirale
	(gimp-image-select-color 
		img								; image 
		0								; operation 
		calque_fond						; drawable 
		Couleur_1_fond_spirale						; color
	)

	; slectionner Couleur_2_fond_spirale
	(gimp-image-select-color 
		img								; image 
		0								; operation 
		calque_fond						; drawable 
		Couleur_2_fond_spirale						; color
	)
	
	; inverser la slection
	(gimp-selection-invert img)

	; sauvegarder cette slection dans un chemin
	(plug-in-sel2path 1 img calque_fond)
	
	; donner un nom au chemin
	(gimp-item-set-name (car (gimp-image-get-active-vectors img)) "trait")	

	; ne rien slectionner
	(gimp-selection-none img)	

	
	
	
	
	
	
	
	
	
; calque_trait_1*********************************************************************************
	

	; crer calque_trait_1
	(set! calque_trait_1 (car (gimp-layer-new img width height 1 "calque_trait_1" 100 0)))	
	
	; ajouter le calque calque_trait_1
	(gimp-image-insert-layer img calque_trait_1 0 -1)
	
	; modifier couleur de premier plan
	(gimp-context-set-foreground Couleur_du_trait_1)
	
	; modifier couleur d'arrire plan
	(gimp-context-set-background Couleur_du_trait_1)
	
	; dfinir le contexte feather et antialias
	(gimp-context-set-feather FALSE)
	
	(gimp-context-set-feather-radius 
		0	; feather-radius-x 
		0	; feather-radius-y
	)

	; slectionner le chemin
	(gimp-image-select-item img 0 (car (gimp-image-get-active-vectors img)))	
	
	; agrandir la slection
	(gimp-selection-grow img (round (/ (+ (* 2 Epaisseur_du_trait_1) Epaisseur_du_trait_2) 2)) )
	
	(gimp-context-set-antialias TRUE)	
	
	; remplir la slection de Couleur_du_trait_1
	(gimp-edit-fill calque_trait_1 0)		

	; ne rien slectionner
	(gimp-selection-none img)	
	
	
	
	
	
	



; calque_trait_2*********************************************************************************
	

	; crer calque_trait_2
	(set! calque_trait_2 (car (gimp-layer-new img width height 1 "calque_trait_2" 100 0)))	
	
	; ajouter le calque calque_trait_2
	(gimp-image-insert-layer img calque_trait_2 0 -1)

	; modifier couleur de premier plan
	(gimp-context-set-foreground Couleur_du_trait_2)
	
	; modifier couleur d'arrire plan
	(gimp-context-set-background Couleur_du_trait_2)
	
	; dfinir le contexte feather et antialias
	(gimp-context-set-feather FALSE)
	
	(gimp-context-set-feather-radius 
		0	; feather-radius-x 
		0	; feather-radius-y
	)

	; slectionner le chemin
	(gimp-image-select-item img 0 (car (gimp-image-get-active-vectors img)))	
	
	; agrandir la slection
	(gimp-selection-grow img (round (/ Epaisseur_du_trait_2 2)) )
	
	(gimp-context-set-antialias TRUE)	
	
	; remplir la slection de Couleur_du_trait_2
	(gimp-edit-fill calque_trait_2 0)		

	; ne rien slectionner
	(gimp-selection-none img)	


	
	
	



; image *********************************************************************************

	
	; dcoupage aux dimensions du motif
	(gimp-image-crop 
		img									; image 
		Dimension_du_motif					; new-width 
		Dimension_du_motif					; new-height 
		(/ (- width Dimension_du_motif) 2)	; offx 
		(/ (- height Dimension_du_motif) 2)	; offy
	)
	
	


	
	
; calque_motif*********************************************************************************



	; crer calque_motif  partir de visible
	(set! calque_motif (car (gimp-layer-new-from-visible img img "calque_motif")))	

	; ajouter le calque calque_motif
	(gimp-image-insert-layer img calque_motif 0 -1)	
	
	
	; Rendre raccordable
	(if
		(= Rendre_raccordable TRUE)
			; appel du greffon 
			(plug-in-make-seamless 1 img  calque_motif)
	)

	
	
	
;*******************************************************************************************
	
	; aplatir l'image
	(if
		(= Aplatir TRUE)
			(gimp-image-flatten img)
	)	
	
	
;*******************************************************************************************
	
	; restaurer PP et AP
	(gimp-context-set-foreground  old-fg)
	(gimp-context-set-background old-bg)
	
	; restaurer ancien dgrad
	(gimp-context-set-gradient old_gradient)
	
	; restaurer brosse
	(gimp-context-set-brush old-brush)

	; ne rien slectionner
	;(gimp-selection-none img)
	
	; afficher l'image
	(gimp-display-new img)

	; End undo group.
	(gimp-image-undo-group-end img)	
	

	


	)
		
)



(script-fu-register
	"Motif_Spirale_samj"
	"<Image>/File/Create/Patterns/Motif spirale..."
	"Crer un motif avec une spirale "
	"samj"
	"samj"
	"2012-06-27"
	""
	SF-ADJUSTMENT "Dimension du motif / Dimension of the pattern (pixels)"  '(256 200 1024 1 8 0 1) ; pixels
	SF-ADJUSTMENT "Nombre approximatif de spires / Approximate number of turns"  '(2 1 10 1 2 0 1) ; pixels
	SF-TOGGLE "Spirale dans le sens horaire / Clockwise spiral" TRUE
	SF-COLOR "Couleur 1 fond spirale / Background color 1 " '(19 61 103) ; 133d67
	SF-COLOR "Couleur 2 fond spirale / Background color 2 " '(104 181 199) ; 68b5c7
	SF-ADJUSTMENT "Epaisseur du trait 1 / Line thickness 1 "  '(4 1 6 1 4 0 1) ; 
	SF-COLOR "Couleur du trait 1 / Line Color 1 " '(239 228 208) ; efe4d0
	SF-ADJUSTMENT "Epaisseur du trait 2 / Line thickness 2 "  '(4 1 6 1 4 0 1) ; 
	SF-COLOR "Couleur du trait 2 / Line Color 2 " '(220 207 191) ; dccfbf
	SF-TOGGLE "Rendre raccordable / Tileable" TRUE
	SF-TOGGLE "Aplatir / Flatten" FALSE

)


; FIN du script