; Pursuit_Curve.scm
; Download : 
;
;	Copyright (C) 2013 samj ( http://aljacom.com/ )
;
;	Licence GPL
;		Ce fichier est le Script-Fu "Pursuit_Curve.scm" pour Gimp. 
;		Ce Script-Fu "Pursuit_Curve.scm" est un logiciel libre ; vous pouvez le redistribuer ou le modifier suivant les termes de la GNU General Public License
;		telle que publie par la Free Software Foundation ; soit la version 3 de la licence, soit ( votre gr) toute version ultrieure.
;		Ce Script-Fu "Pursuit_Curve.scm" est distribu dans l'espoir qu'il sera utile, mais SANS AUCUNE GARANTIE ; 
;		pas mme la garantie implicite de COMMERCIABILISABILIT ni d'ADQUATION  UN OBJECTIF PARTICULIER.
;		Consultez la GNU General Public License pour plus de dtails.
;		Vous devez avoir reu une copie de la GNU General Public License en mme temps que GIMP ; si ce n'est pas le cas, consultez <http://www.gnu.org/licenses>
;
;	Ce fichier Pursuit_Curve.scm est dit avec Notepad++    http://notepad-plus-plus.org/
;
;
;	Version 2 du 20130525 - Modifications selon les conseils de Saulgoode et ajout "Variation forme polygone"
;	Version 1 du 20130525
;
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;
;	Courbe de poursuite mutuelle
;	Chaque polygone est sauvegard sous forme de chemin.
;	Each polygon is saved as a path.
;
;	Accs par :
;
;	Fichier > Crer > Motifs > Pursuit Curve ...
;	File > Create > Patterns > Pursuit Curve ...
;
;	http://en.wikipedia.org/wiki/Pursuit_curve
;
;
;
;
;
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;
;
; Inspiration :
;			http://www.mathcurve.com/courbes2d/poursuite/poursuitemutuelle.shtml
;			http://ressources.univ-lemans.fr/AccesLibre/UM/Pedago/physique/02/meca/poursuite.html
;			http://did.mat.uni-bayreuth.de/material/verfolgung/node15.html
;			http://www.mathcurve.com/courbes2d/logarithmic/logarithmic.shtml
;			http://en.wikipedia.org/wiki/Logarithmic_spiral
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;
;
;

		
(define	
	(
		Pursuit_Curve_samj
		Dimension
		Number_of_sides
		Minimum_Value_Of_The_Polygon
		Departure_Angle
		Pursuit_Angle
		Coefficient_Agrandissement_Spirale
		Type_representation
		Variation_forme_polygone
		Color_Pencil_1
		Pencil_1_Line_Thickness
		Color_intensity
		Autocrop_Image
		Remplir_toute_l_image

		
	)
	(let* 
		(

			(message (car (gimp-message-get-handler)))
			(old-fg (car (gimp-context-get-foreground)))
			(old-bg (car (gimp-context-get-background)))

			(old-brush-size (car (gimp-context-get-brush-size)))
			(old-brush-aspect-ratio (car (gimp-context-get-brush-aspect-ratio)))
			(old-brush-angle (car (gimp-context-get-brush-angle)))
			(old-brush-name (car (gimp-context-get-brush)))
			
			(old-pattern (car (gimp-context-get-pattern)))

			(width (+ Dimension Pencil_1_Line_Thickness) )
			(height (+ Dimension Pencil_1_Line_Thickness) )
			(image)
			
			;calque_fond
			(calque_fond)

			(2pi (* 2 3.14159265358979323846) )

			(X_1 0)
			(Y_1 0)

			(rayon_cercle_inscrit 0)
			(rayon_cercle_circonscrit 0)
			(rayon_cercle_circonscrit_polygone_en_cours 0)


			(sortie_boucle_tracer 0)
			(Nom_de_la_brosse "Ma_Brosse_Spirale_samj")
			(The_shape_of_the_generated_brush 0) ; "Circle" "Square" "Diamond"
			(rayon_brosse (/ Pencil_1_Line_Thickness 2) )

			(sortie_boucle 0)
			(nombre_de_boucle 0)

			(sortie_boucle_creation_polygone 0)
			(nombre_boucle_creation_polygone 0)

			(angle_polygone  (/ 2pi Number_of_sides)   )
			
			(angle_en_cours 0)
			(sinus_angle_sommet_polygone 0)
			(angle_sommet_polygone 0)			
			(chemin_polygone)
			(Points_chemin_polygone)
			(Ajout_Points_chemin_polygone)
			(Nombre_Points_chemin_polygone 0)
			(X_polygone 0)
			(Y_polygone 0)
			(X_total_polygone 0)
			(Y_total_polygone 0)
			(nombre_boucle_spirale 0)

		)

		; sauvegard le contexte.  Recommand par Saulgoode http://gimpchat.com/viewtopic.php?f=9&t=7342#p93780
		(gimp-context-push)

		(gimp-context-set-antialias FALSE)
		(gimp-context-set-feather FALSE)
		(gimp-context-set-feather-radius 0 0)
		(gimp-context-set-sample-merged FALSE)
		(gimp-context-set-sample-criterion 0)
		(gimp-context-set-sample-threshold 0.15)
		(gimp-context-set-sample-transparent FALSE)

		(gimp-context-set-transform-direction TRANSFORM-FORWARD)
		(gimp-context-set-interpolation 2)
		(gimp-context-set-transform-recursion 3)
		(gimp-context-set-transform-resize TRANSFORM-RESIZE-ADJUST)
		
		(gimp-context-set-paint-mode 0) ;


;******************************************************************************************************
; 
;******************************************************************************************************

	




	; crer une nouvelle image rgb
	(set! image (car (gimp-image-new width height 0)))

	;; Start undo. Recommand par Saulgoode http://gimpchat.com/viewtopic.php?f=9&t=7342#p93780
	(gimp-image-undo-disable image)

	;; slectionner la console erreurs pour envoyer un message
	(gimp-message-set-handler 2)

	; crer calque_fond
	(set! calque_fond (car (gimp-layer-new image width height 1 "calque_fond" 100 0)))	
	
	; ajouter le calque calque_fond
	(gimp-image-insert-layer image calque_fond 0 -1)

	(gimp-drawable-fill calque_fond 3)

;******************************************************************************************************
; 
;******************************************************************************************************


	(gimp-context-set-foreground Color_Pencil_1)

	; crer une brosse
	(gimp-brush-new Nom_de_la_brosse)				

	(gimp-context-set-brush-size rayon_brosse )
	;;;(gimp-context-set-brush-default-size)
	(gimp-context-set-brush-aspect-ratio 1)
	(gimp-context-set-brush-angle 0)
	
	(gimp-context-set-brush Nom_de_la_brosse)

	(gimp-brush-set-shape Nom_de_la_brosse The_shape_of_the_generated_brush) ; forme

	(gimp-brush-set-radius Nom_de_la_brosse rayon_brosse ) ; rayon

	(gimp-brush-set-spikes Nom_de_la_brosse 2) ; pointes
	(gimp-brush-set-hardness Nom_de_la_brosse 1.0) ; duret 
	(gimp-brush-set-aspect-ratio Nom_de_la_brosse 1 ) ; proportions
	(gimp-brush-set-angle Nom_de_la_brosse 0) ; angle
	(gimp-brush-set-spacing Nom_de_la_brosse 1.0 ) ; espacement




	;transformation degrs radians
	(set! Departure_Angle (* (/ 2pi 360) Departure_Angle) )
	(set! Pursuit_Angle (* (/ 2pi 360) Pursuit_Angle) )
	; angle_polygone en radians
	(if (< Variation_forme_polygone 100) (set! angle_polygone (* (/ angle_polygone 100) Variation_forme_polygone)  )      )

	; limites (cercle inscrit pour carr, ou plus grand cercle contenu)
	(set! rayon_cercle_inscrit (/ (min width height) 2) )	
	(set! rayon_cercle_circonscrit (/ (sqrt (+ (* width width) (* height height) ) ) 2) )


	(set! sortie_boucle 0 )
	(set! nombre_de_boucle 0)


	(while (= sortie_boucle 0)
		(begin

			(set! nombre_de_boucle (+ nombre_de_boucle 1) )
			; (gimp-message (number->string nombre_de_boucle) )

			(set! angle_en_cours (* nombre_de_boucle Pursuit_Angle) )

			(if (= Type_representation 0)
				(begin
					(set! X_1  (* (exp (* Coefficient_Agrandissement_Spirale angle_en_cours))  (cos angle_en_cours) )   )
					(set! Y_1  (* (exp (* Coefficient_Agrandissement_Spirale angle_en_cours))  (sin angle_en_cours) )   )
				)
			)
			(if (= Type_representation 1)
				(begin
					(set! X_1  (* (exp (* Coefficient_Agrandissement_Spirale angle_en_cours))  (sin angle_en_cours) )   )
					(set! Y_1  (* (exp (* Coefficient_Agrandissement_Spirale angle_en_cours))  (cos angle_en_cours) )   )
				)
			)

			(set! rayon_cercle_circonscrit_polygone_en_cours (sqrt (+ (* X_1 X_1) (* Y_1 Y_1) ) )  )
			(set! sinus_angle_sommet_polygone (/ Y_1 rayon_cercle_circonscrit_polygone_en_cours ) )
			(set! angle_sommet_polygone (asin  sinus_angle_sommet_polygone)  )
			; (gimp-message (strcat "X_1 : " (number->string X_1) " Y_1 : " (number->string Y_1) " R : " (number->string rayon_cercle_circonscrit_polygone_en_cours) " A : " (number->string angle_sommet_polygone)  ) )


			; conditions de sortie
			(if (> nombre_de_boucle 8260) (set! sortie_boucle 1 ) )	; Pour ventuellement crer des chemins par sommets de polygone. Chemins fonctionnent avec  8280 , ne fonctionne pas avec 8370

			(if (= Remplir_toute_l_image 1)
				(begin
					(if (> rayon_cercle_circonscrit_polygone_en_cours rayon_cercle_circonscrit) (set! sortie_boucle 1 ) )
				)
				;else
				(begin
					(if (> rayon_cercle_circonscrit_polygone_en_cours rayon_cercle_inscrit) (set! sortie_boucle 1 ) )
				)
			)




			(set! sortie_boucle_creation_polygone 0)
			(set! nombre_boucle_creation_polygone 0)

			(while (= sortie_boucle_creation_polygone 0)

					(set! nombre_boucle_creation_polygone (+ nombre_boucle_creation_polygone 1) )
					(if (> (+ nombre_boucle_creation_polygone 1) Number_of_sides) (set! sortie_boucle_creation_polygone 1 ) )

					(if (> rayon_cercle_circonscrit_polygone_en_cours Minimum_Value_Of_The_Polygon)
						(begin

							; cration valeurs de chaque chemin polygone
							(set! X_polygone (* rayon_cercle_circonscrit_polygone_en_cours (cos (+ angle_sommet_polygone Departure_Angle (* nombre_boucle_creation_polygone angle_polygone)  )   )  )  )
							(set! Y_polygone (* rayon_cercle_circonscrit_polygone_en_cours (sin (+ angle_sommet_polygone Departure_Angle (* nombre_boucle_creation_polygone angle_polygone)  )   )  )  )
							(set! X_total_polygone (+ (/ width 2) X_polygone) )
							(set! Y_total_polygone (+ (/ height 2) Y_polygone) )
							; (gimp-message (strcat "R : " (number->string rayon_cercle_circonscrit_polygone_en_cours) " X : " (number->string X_total_polygone) " Y : " (number->string Y_total_polygone )  " P : " (number->string Nombre_Points_chemin_polygone )   )  )
							(if (= nombre_boucle_creation_polygone 1)
								(begin
									(set! Points_chemin_polygone (list X_total_polygone Y_total_polygone X_total_polygone Y_total_polygone X_total_polygone Y_total_polygone ) )
									(set! Nombre_Points_chemin_polygone 6 )
								)
								;else
								(begin
									(set! Ajout_Points_chemin_polygone (list X_total_polygone Y_total_polygone X_total_polygone Y_total_polygone X_total_polygone Y_total_polygone ) )
									(set! Points_chemin_polygone (append Points_chemin_polygone Ajout_Points_chemin_polygone) )
									(set! Nombre_Points_chemin_polygone (+ 6 Nombre_Points_chemin_polygone ) )
								)
							)

						)


					)

			)

			(if (> rayon_cercle_circonscrit_polygone_en_cours Minimum_Value_Of_The_Polygon)
				(begin
					(set! chemin_polygone (car (gimp-vectors-new image "Polygone") ) )
					(gimp-image-insert-vectors image chemin_polygone 0 -1)

					(gimp-vectors-stroke-new-from-points
						chemin_polygone
						0
						Nombre_Points_chemin_polygone
						(list->vector Points_chemin_polygone )
						1
					)

					; slectionner brosse
					(gimp-context-set-brush Nom_de_la_brosse)

					(set! sortie_boucle_tracer Color_intensity)

					(while (> sortie_boucle_tracer 0)
						(begin
							(gimp-edit-stroke-vectors calque_fond (car (gimp-image-get-active-vectors image) ) )
							(set! sortie_boucle_tracer (- sortie_boucle_tracer 1) )
						)
					)
				)

			)



		)
	)





;******************************************************************************************************
; 
;******************************************************************************************************


	(gimp-brush-delete Nom_de_la_brosse)


	(if (= 1 Autocrop_Image) (plug-in-autocrop-layer 1 image calque_fond) )

	
	; ajuster taille image  la taille des calques
	(gimp-image-resize-to-layers image)



;******************************************************************************************************
; 
;******************************************************************************************************

		;; rtablir le mode message
		(gimp-message-set-handler message)

		; restituer l'ancien contexte.  Recommand par Saulgoode http://gimpchat.com/viewtopic.php?f=9&t=7342#p93780
		(gimp-context-pop)



;******************************************************************************************************
; 
;******************************************************************************************************


		; afficher l'image
		(gimp-display-new image)

		; End undo. Recommand par Saulgoode http://gimpchat.com/viewtopic.php?f=9&t=7342#p93780
		(gimp-image-undo-enable image)





	)
)



; ancienne mthode
;(script-fu-register "Pursuit_Curve_samj"
;                    _"<Image>/File/Create/Patterns/Pursuit Curve ..."

; Nouvelle mthode recommand par Saulgoode http://gimpchat.com/viewtopic.php?f=9&t=7342#p93780
(script-fu-register "Pursuit_Curve_samj"
                    _"Pursuit Curve ..."
                    "Pursuit Curve ..."
                    "samj"
                    "samj"
                    "20130525"
                    ""
					SF-ADJUSTMENT "Dimension " '(400 64 1600 1 5 0 1)
					SF-ADJUSTMENT "Number Of Sides " '(4 3 32 1 2 0 1)
					SF-ADJUSTMENT "Minimum Value Of The Polygon " '(16 0 32 1 2 0 1)
					SF-ADJUSTMENT "Departure Angle " '(0 0 360 1 5 4 1)
					SF-ADJUSTMENT "Pursuit Angle " '(15 0.5 360 1 5 4 1)
					SF-ADJUSTMENT "Coefficient Of Expansion " '(0.7 0.02 1000 0.1 0.5 4 1)
					SF-OPTION "Type " '("A" "B") 
					SF-ADJUSTMENT "Variation forme polygone " '(100 50 100 1 5 4 1)
					SF-COLOR "Color Pencil 1 " '(0 0 0)
					SF-ADJUSTMENT "Pencil 1 - Line Thickness " '(2 1 40 1 5 0 1)
					SF-ADJUSTMENT "Color Intensity " '(3 1 10 1 5 0 1)
					SF-TOGGLE "Autocrop " FALSE
					SF-TOGGLE "Fill The Entire Image " FALSE

					


)

; Nouvelle mthode recommand par Saulgoode http://gimpchat.com/viewtopic.php?f=9&t=7342#p93780
(script-fu-menu-register "Pursuit_Curve_samj"
                    _"<Image>/File/Create/Patterns"
)




;; FIN





