; Script-Fu_Dot_Lines.scm
; Download : 
;
;	Copyright (C) 2013 samj ( http://aljacom.com/ )
;
;	Licence GPL
;		Ce fichier est le Script-Fu "Script-Fu_Dot_Lines.scm" pour Gimp. 
;		Ce Script-Fu "Script-Fu_Dot_Lines.scm" est un logiciel libre ; vous pouvez le redistribuer ou le modifier suivant les termes de la GNU General Public License
;		telle que publie par la Free Software Foundation ; soit la version 3 de la licence, soit ( votre gr) toute version ultrieure.
;		Ce Script-Fu "Script-Fu_Dot_Lines.scm" est distribu dans l'espoir qu'il sera utile, mais SANS AUCUNE GARANTIE ; 
;		pas mme la garantie implicite de COMMERCIABILISABILIT ni d'ADQUATION  UN OBJECTIF PARTICULIER.
;		Consultez la GNU General Public License pour plus de dtails.
;		Vous devez avoir reu une copie de la GNU General Public License en mme temps que GIMP ; si ce n'est pas le cas, consultez <http://www.gnu.org/licenses>
;
;	Ce fichier Script-Fu_Dot_Lines.scm est dit avec Notepad++    http://notepad-plus-plus.org/
;
;
;	Version 20130624 (origine)  24 juin 2013, Fte nationale du Qubec :o)
;
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;
;
;
;	Accs sur l'image par :
;
;	Filtres > Mappage > Dot Lines ...
;	Filters > Map > Dot Lines ...
;
;
;
;
;	Origine :
;				- Ce script-fu est une adaptation d'un autre script utilis pour crer des images  crayonner pour les enfants.
;
;
;	Principes :
;				- L'utilisation des images  couleurs indexes permet d'obtenir des zones uniformes de couleurs.
;				- La transformation en niveaux de gris permet de slectionner rapidement ces zones uniformes, de les transformer en masques pour produire d'autres effets.
;
;	Utilisation
;				- Utiliser des images bien contrastes, ventuellement augmenter les contrastes avec Gimp.
;				- L'option "Rounded Lines (blur)" permet d'avoir des contours arrondis.
;				- L'option "Soften" permet d'arrondir les pointes.
;
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;
;


(define	
	(
		Script-Fu_Dot_Lines_samj
		image
		drawable
		Pretreatments
		Rounded_Lines
		Soften
		rayon_brosse
		espacement_entre_points
		espacement_entre_lignes
		The_shape_of_the_generated_brush



	)
	(let* 
		(

			(message (car (gimp-message-get-handler)))


			(width (car (gimp-image-width image)))
			(height (car (gimp-image-height image)))

			(transparence (car (gimp-drawable-has-alpha drawable)))

			(selection_en_cours)
			(nouvelle_image)
			(calque_copie)
			(copier_visible)
			(buffer-name "copier_visible")
			(rvb 0)
			(selection_bounds 0)
			(select_exist 0)
			(select_offset_x 0)
			(select_offset_y 0)
			(select_width 0)
			(select_height 0)
			(sortie_boucle 0)


			(matrix 0)
			(matrix-list 0)
			(channels 0)

			(masque_1)
			(masque_2)
			(points_gris)

			(Nb_masque 0)


			(Nom_de_la_brosse "Ma_Brosse_Spirale_samj")
			;;;;;;;;;;(The_shape_of_the_generated_brush 0) ; "Circle" "Square" "Diamond"
			(Nom_du_chemin "")
			(Nb_chemins 0)
			(Nb_boucles 0)
			(sortie_boucle_tracer 0)





		)


		; pour image existante
		(gimp-undo-push-group-start image) 
		
		;; Start undo. Recommand par Saulgoode pour nouvelle image http://gimpchat.com/viewtopic.php?f=9&t=7342#p93780
		; (gimp-image-undo-disable image)

		; sauvegard le contexte.  Recommand par Saulgoode http://gimpchat.com/viewtopic.php?f=9&t=7342#p93780
		(gimp-context-push)

		;; slectionner la console erreurs pour envoyer un message
		(gimp-message-set-handler 2)

		(gimp-selection-none image)



		(gimp-context-set-antialias TRUE)
		(gimp-context-set-feather TRUE)
		(gimp-context-set-feather-radius 2 2)
		(gimp-context-set-sample-merged FALSE)
		(gimp-context-set-sample-criterion 0)
		(gimp-context-set-sample-threshold 0)
		(gimp-context-set-sample-transparent TRUE)

		(gimp-context-set-transform-direction TRANSFORM-FORWARD)
		(gimp-context-set-interpolation 2)
		(gimp-context-set-transform-recursion 3)
		(gimp-context-set-transform-resize TRANSFORM-RESIZE-ADJUST)
		
		(gimp-context-set-paint-mode 0) ;

;******************************************************************************************************
; 
;******************************************************************************************************


		(set! copier_visible (car (gimp-edit-named-copy-visible image buffer-name)))

		; crer une nouvelle image rgb
		(set! nouvelle_image (car (gimp-image-new width height 0)))

		;; Start undo. Recommand par Saulgoode pour nouvelle image http://gimpchat.com/viewtopic.php?f=9&t=7342#p93780
		(gimp-image-undo-disable nouvelle_image)


		; crer le premier calque
		(set! calque_copie (car (gimp-layer-new nouvelle_image width height 0 "fond" 100 0)))

		(gimp-image-insert-layer nouvelle_image calque_copie -1 0)

		(gimp-image-select-rectangle nouvelle_image 0  width height 0 0 )

		(set! selection_en_cours (car (gimp-edit-named-paste calque_copie copier_visible 0)))

		(gimp-floating-sel-anchor selection_en_cours)

		(gimp-selection-none nouvelle_image)

		(gimp-layer-add-alpha calque_copie)

		(gimp-levels-stretch calque_copie)
		(gimp-equalize calque_copie TRUE)

		; ajuster taille image  la taille des calques
		(gimp-image-resize-to-layers nouvelle_image)

		(set! calque_copie (car (gimp-image-get-active-layer nouvelle_image)))


		(if (or (= Pretreatments 1) (= Pretreatments 3) ) ; "B For dark images"
			(begin

				(set! matrix-list
					'(
						0		0		0		0		0
						0		1		0		0		0
						0		0		1		0		0
						0		0		0		0		0
						0		0		0		0		0
					 )
				)

				(set! channels (make-vector 5 'long ))

				(vector-set! channels 0 1 )
				(vector-set! channels 1 1 )
				(vector-set! channels 2 1 )
				(vector-set! channels 3 1 )
				(vector-set! channels 4 1 )

				; Convert maxtrix list (25) into matrix array (5x5)
				(define (get-matrix matrix-list)
				  (let* (
						(n 0)
						)
				  (set! n 25 )
				  (define (list-ref l n) (nth n l))
					(let* ((count 0)
						   (matrix (cons-array 25 'double)))
					  (while (< count 25 )
					  (aset matrix count (list-ref matrix-list count))
					  (set! count (+ count 1)))
					  matrix ; Return the matrix array
					)
				  )
				)

				; (plug-in-convmatrix run-mode image drawable argc-matrix matrix alpha-alg divisor offset argc-channels channels bmode)
				(plug-in-convmatrix 1 nouvelle_image calque_copie 25 (set! matrix (get-matrix matrix-list)) 1 1 0 5 channels 0)


			)
		)


		(if (or (= Pretreatments 2) (= Pretreatments 3) ) ; "C Low contrast picture"
			(begin


				(set! matrix-list
					'(
						-1		0		0		0		0
						0		1		0		0		0
						0		0		1		0		0
						0		0		0		0		0
						0		0		0		0		0
					 )
				)

				(set! channels (make-vector 5 'long ))

				(vector-set! channels 0 1 )
				(vector-set! channels 1 1 )
				(vector-set! channels 2 1 )
				(vector-set! channels 3 1 )
				(vector-set! channels 4 1 )

				; Convert maxtrix list (25) into matrix array (5x5)
				(define (get-matrix matrix-list)
				  (let* (
						(n 0)
						)
				  (set! n 25 )
				  (define (list-ref l n) (nth n l))
					(let* ((count 0)
						   (matrix (cons-array 25 'double)))
					  (while (< count 25 )
					  (aset matrix count (list-ref matrix-list count))
					  (set! count (+ count 1)))
					  matrix ; Return the matrix array
					)
				  )
				)

				; (plug-in-convmatrix run-mode image drawable argc-matrix matrix alpha-alg divisor offset argc-channels channels bmode)
				(plug-in-convmatrix 1 nouvelle_image calque_copie 25 (set! matrix (get-matrix matrix-list)) 1 1 0 5 channels 0)



			)
		)

		(gimp-desaturate-full calque_copie 1)

		(gimp-posterize calque_copie 2)

		(if (> Rounded_Lines 0) 
			;;;;;(plug-in-gauss 1 nouvelle_image calque_copie (round (+ 1 (/ width 40)))  (round (+ 1 (/ height 40)))   1)
			(plug-in-gauss 1 nouvelle_image calque_copie Rounded_Lines  Rounded_Lines   1)
		)

		(gimp-convert-indexed nouvelle_image 0 0 2 1 1 "")

		(gimp-image-convert-grayscale nouvelle_image)

		(gimp-image-convert-rgb nouvelle_image)





		;******************************************************************************************************
		; crer les calques utiliss comme masques
		;******************************************************************************************************

		(gimp-context-set-background '(0 0 0))
		(gimp-context-set-foreground '(255 255 255))

		(set! sortie_boucle 0)
		(set! rvb -1)




		; boucle pour trouver les couleurs, faire une slection par couleur , crer les masques
		(while
			(= sortie_boucle 0)
				(begin

					(set! rvb (+ rvb 1) )
					(if (= rvb 256)
						(begin
							(set! sortie_boucle 1 )
						)
					)

					(gimp-selection-none nouvelle_image)

					(if (= sortie_boucle 0)
						(begin

							(gimp-image-select-color nouvelle_image 0 calque_copie (list rvb rvb rvb))
							(gimp-selection-feather nouvelle_image 0)

							(set! selection_bounds (gimp-selection-bounds nouvelle_image))
							(set! select_exist (car selection_bounds))
							;(set! select_offset_x (cadr selection_bounds))
							;(set! select_offset_y (caddr selection_bounds))
							;(set! select_width (- (cadr (cddr selection_bounds)) select_offset_x))
							;(set! select_height (- (caddr (cddr selection_bounds)) select_offset_y))
							;(gimp-message (number->string select_exist))

							(if (= select_exist 1)
								(begin

									(if (> Soften 0)
										(begin
											(gimp-selection-grow nouvelle_image Soften)
											(gimp-selection-shrink nouvelle_image Soften)
										)
									)

									(set! Nb_masque (+ Nb_masque 1) )

									(if (> Nb_masque 2)
										(begin
											(set! sortie_boucle 1 )
										)
										;else
										(begin

											; (gimp-message (number->string Nb_masque) )

											(if (= Nb_masque 1)
												(begin
													(set! masque_1 (car (gimp-layer-new nouvelle_image width height 1 "masque_1" 100 0)))
													(gimp-image-insert-layer nouvelle_image masque_1 -1 0)
													(gimp-drawable-fill masque_1 3)
													(gimp-edit-fill masque_1 1) ; background
													(gimp-item-set-visible masque_1 TRUE)
													(gimp-selection-none nouvelle_image)
													; (gimp-message (number->string rvb) )
												)
											)

											(if (= Nb_masque 2)
												(begin
													(set! masque_2 (car (gimp-layer-new nouvelle_image width height 1 "masque_2" 100 0)))
													(gimp-image-insert-layer nouvelle_image masque_2 -1 0)
													(gimp-drawable-fill masque_2 3)
													(gimp-edit-fill masque_2 1) ; background
													(gimp-item-set-visible masque_2 TRUE)
													(gimp-selection-none nouvelle_image)
													; (gimp-message (number->string rvb) )
												)
											)




										)
									)




								)
							)




						
						)
					)



				)
		)


		(gimp-selection-none nouvelle_image)

		; (gimp-image-remove-layer nouvelle_image calque_copie)




;******************************************************************************************************
; effet Dot Lines
;******************************************************************************************************



		(gimp-image-select-rectangle nouvelle_image 0  width height 0 0 )

		(set! selection_en_cours (car (gimp-edit-named-paste calque_copie copier_visible 0)))

		(gimp-floating-sel-anchor selection_en_cours)

		(gimp-selection-none nouvelle_image)

		; crer le calque points_gris
		(set! points_gris (car (gimp-layer-new nouvelle_image width height 1 "points_gris" 100 0)))
		(gimp-image-insert-layer nouvelle_image points_gris -1 0)
		(gimp-drawable-fill points_gris 3) ; transparent
		; (gimp-edit-fill points_gris 2) ; white
		(gimp-item-set-visible points_gris TRUE)

		(gimp-context-set-foreground '(127 127 127) )

		; crer une brosse
		(gimp-brush-new Nom_de_la_brosse)				

		(gimp-context-set-brush-size rayon_brosse )
		;;;(gimp-context-set-brush-default-size)
		(gimp-context-set-brush-aspect-ratio 1)
		(gimp-context-set-brush-angle 0)
		
		(gimp-context-set-brush Nom_de_la_brosse)

		(gimp-brush-set-shape Nom_de_la_brosse The_shape_of_the_generated_brush) ; forme

		(gimp-brush-set-radius Nom_de_la_brosse rayon_brosse ) ; rayon

		(gimp-brush-set-spikes Nom_de_la_brosse 2) ; pointes
		(gimp-brush-set-hardness Nom_de_la_brosse 0.5) ; duret 
		(gimp-brush-set-aspect-ratio Nom_de_la_brosse 1 ) ; proportions
		(gimp-brush-set-angle Nom_de_la_brosse 0) ; angle
		(gimp-brush-set-spacing Nom_de_la_brosse espacement_entre_points ) ; espacement

		; slectionner brosse
		(gimp-context-set-brush Nom_de_la_brosse)

		(set! Nb_chemins 0)

		; masque_1
		(gimp-image-select-color nouvelle_image 2 masque_1 '(0 0 0) )

		; boucle pour tracer les points du calque masque_1
		(set! sortie_boucle 0)
		(set! Nb_boucles 0)

		(while
			(= sortie_boucle 0)
				(begin

					(set! Nb_boucles (+ Nb_boucles 1) )

					(set! selection_bounds (gimp-selection-bounds nouvelle_image))
					(set! select_exist (car selection_bounds))
					;(set! select_offset_x (cadr selection_bounds))
					;(set! select_offset_y (caddr selection_bounds))
					;(set! select_width (- (cadr (cddr selection_bounds)) select_offset_x))
					;(set! select_height (- (caddr (cddr selection_bounds)) select_offset_y))
					;(gimp-message (number->string select_exist))

					(if (= select_exist 0)
						(begin
							(set! sortie_boucle 1 )
						)
						;else
						(begin

							(set! Nb_chemins (+ Nb_chemins 1) )
							(set! Nom_du_chemin (string-append "Chemin_"  (number->string Nb_chemins) ) )

							; sauvegarde slection vers chemin
							(plug-in-sel2path 1 nouvelle_image masque_1)

							; donner un nom au chemin
							(gimp-item-set-name (car (gimp-image-get-active-vectors nouvelle_image)) Nom_du_chemin )

							(gimp-selection-none nouvelle_image)

							(set! sortie_boucle_tracer 10)

							(while (> sortie_boucle_tracer 0)
								(begin
									(gimp-edit-stroke-vectors points_gris (car (gimp-image-get-active-vectors nouvelle_image) ) )
									(set! sortie_boucle_tracer (- sortie_boucle_tracer 1) )
								)
							)
								
							(gimp-image-select-color nouvelle_image 2 masque_1 '(0 0 0) )
							(gimp-selection-shrink nouvelle_image (* espacement_entre_lignes Nb_boucles) )

						)
					)

				)
		)




		; masque_2
		(gimp-image-select-color nouvelle_image 2 masque_2 '(0 0 0) )

		; boucle pour tracer les points du calque masque_2
		(set! sortie_boucle 0)
		(set! Nb_boucles 0)

		(while
			(= sortie_boucle 0)
				(begin

					(set! Nb_boucles (+ Nb_boucles 1) )

					(gimp-selection-shrink nouvelle_image (* espacement_entre_lignes Nb_boucles) )

					(set! selection_bounds (gimp-selection-bounds nouvelle_image))
					(set! select_exist (car selection_bounds))
					;(set! select_offset_x (cadr selection_bounds))
					;(set! select_offset_y (caddr selection_bounds))
					;(set! select_width (- (cadr (cddr selection_bounds)) select_offset_x))
					;(set! select_height (- (caddr (cddr selection_bounds)) select_offset_y))
					;(gimp-message (number->string select_exist))

					(if (= select_exist 0)
						(begin
							(set! sortie_boucle 1 )
						)
						;else
						(begin

							(set! Nb_chemins (+ Nb_chemins 1) )
							(set! Nom_du_chemin (string-append "Chemin_"  (number->string Nb_chemins) ) )

							; sauvegarde slection vers chemin
							(plug-in-sel2path 1 nouvelle_image masque_2)

							; donner un nom au chemin
							(gimp-item-set-name (car (gimp-image-get-active-vectors nouvelle_image)) Nom_du_chemin )

							(gimp-selection-none nouvelle_image)

							(set! sortie_boucle_tracer 10)

							(while (> sortie_boucle_tracer 0)
								(begin
									(gimp-edit-stroke-vectors points_gris (car (gimp-image-get-active-vectors nouvelle_image) ) )
									(set! sortie_boucle_tracer (- sortie_boucle_tracer 1) )
								)
							)
								
							(gimp-image-select-color nouvelle_image 2 masque_2 '(0 0 0) )


						)
					)

				)
		)






;******************************************************************************************************
; code pour script_fu_gmic_cordes.scm , tlchargement http://gimpchat.com/viewtopic.php?f=28&t=7642
;******************************************************************************************************




		; G'MIC filter : Dream smoothing - Author: Arto Huotari , modifi pour script-fu
;		(plug-in-gmic 1 nouvelle_image points_gris 1
;			(string-append
;				"-v - " ; To have a silent output. Remove it to display errors from the G'MIC interpreter on stderr.
;				"Iterations=2 "
;				"Eqa=1 "
;				"MergingOption=1 "
;				"Opacity=0.8 "
;				"ReverseOrder=0 "
;				"Smoothness=0.8 "
;				"-repeat $Iterations "
;				"IWidth={round(@{0,w}/(@{<,-1}+1))} "
;				"IHeight={round(@{0,h}/(@{<,-1}+1))} "
;				"-if {@{>,-1}!=0} "
;				"-r[-1] $IWidth,$IHeight,1,4,5,1 "
;				"-endif "
;				"--r[0] $IWidth,$IHeight,1,4,5,1 "
;				"-gimp_anisotropic_smoothing[-1] {430/$Iterations*(@{<,-1}+1)},0.4,0.5,0.6,2,0.8,30,2,0,0,1,0,1,0 "
;				"-gimp_anisotropic_smoothing[-1] {600/$Iterations*(@{<,-1}+1)},0.4,1,0.6,4,0.8,15,5,0,1,1,0,1,0 "
;				"-if {@{>,-1}!=0} "
;				"-blend[-1,-2] alpha,$Opacity,$ReverseOrder "
;				"-if {$Eqa} -equalize[-1] 256 -endif "
;				"-done "
;				"-keep[-1] "
;
;			)
;		)

;		(gimp-levels-stretch points_gris)

;		(gimp-item-set-visible points_gris FALSE)
;		(gimp-item-set-visible masque_1 FALSE)
;		(gimp-item-set-visible masque_2 FALSE)

		;(plug-in-bump-map run-mode image drawable bumpmap azimuth elevation depth xofs yofs waterlevel ambient compensate invert type)
;		(plug-in-bump-map RUN-NONINTERACTIVE nouvelle_image calque_copie points_gris 135 45 2 0 0 0 0 TRUE FALSE 0)
;		(plug-in-bump-map RUN-INTERACTIVE nouvelle_image calque_copie points_gris 135 45 2 0 0 0 0 TRUE FALSE 0)


;******************************************************************************************************
; code pour Dot Lines
;******************************************************************************************************



		(gimp-levels-stretch points_gris)
		(gimp-invert points_gris) ;------------------------------------------------------------graechan


		(gimp-item-set-visible points_gris FALSE)
		(gimp-item-set-visible masque_1 FALSE)
		(gimp-item-set-visible masque_2 FALSE)

		;(plug-in-bump-map run-mode image drawable bumpmap azimuth elevation depth xofs yofs waterlevel ambient compensate invert type)
		(plug-in-bump-map RUN-INTERACTIVE nouvelle_image calque_copie points_gris 135 45 2 0 0 0 0 TRUE FALSE 0)







;******************************************************************************************************
; 
;******************************************************************************************************

		(gimp-brush-delete Nom_de_la_brosse)

		(gimp-display-new nouvelle_image)

		; End undo. Recommand par Saulgoode pour nouvelle image http://gimpchat.com/viewtopic.php?f=9&t=7342#p93780
		(gimp-image-undo-enable nouvelle_image)




;******************************************************************************************************
; 
;******************************************************************************************************

		;; rtablir le mode message
		(gimp-message-set-handler message)

		; restituer l'ancien contexte.  Recommand par Saulgoode http://gimpchat.com/viewtopic.php?f=9&t=7342#p93780
		(gimp-context-pop)

		; End undo. Recommand par Saulgoode pour nouvelle image http://gimpchat.com/viewtopic.php?f=9&t=7342#p93780
		;(gimp-image-undo-enable image)

		; pour image existante
		(gimp-undo-push-group-end image)

		(gimp-displays-flush)


	)
)



; Nouvelle mthode recommand par Saulgoode http://gimpchat.com/viewtopic.php?f=9&t=7342#p93780
(script-fu-register "Script-Fu_Dot_Lines_samj"
                    _"Dot Lines ..."
                    "Dot Lines ..."
                    "samj"
                    "samj"
                    "20130624"
                    "RGB*"
                    SF-IMAGE    "Image"     0
                    SF-DRAWABLE "Drawable"  0
					SF-OPTION "Pretreatments " '("A  Without" "B  For dark images" "C  Low contrast picture" "  B + C  ")
					SF-ADJUSTMENT "Pretreatment Blur " '(4 0 60 1 5 0 1)
					SF-ADJUSTMENT "Pretreatment Soften " '(4 0 60 1 5 0 1)
					SF-ADJUSTMENT "Dot Size (pixels) " '(4 1 20 1 5 0 1)
					SF-ADJUSTMENT "Spacing Between Dots (%) " '(100 25 200 1 5 2 1)
					SF-ADJUSTMENT "Spacing Between Lines Of Points (pixels) " '(6 4 20 1 5 2 1)
					SF-OPTION "The shape of the generated brush " '("Circle" "Square" "Diamond" )






)

; Nouvelle mthode recommand par Saulgoode http://gimpchat.com/viewtopic.php?f=9&t=7342#p93780
(script-fu-menu-register "Script-Fu_Dot_Lines_samj"
					_"<Image>/Filters/Map"
)



;; FIN





