; Selection_Transformation_1.scm
; Download : 
;
;	Copyright (C) 2013 samj ( http://www.aljacom.com/ )
;
;	Licence GPL
;		Ce fichier est le Script-Fu "Selection_Transformation_1.scm" pour Gimp. 
;		Ce Script-Fu "Selection_Transformation_1.scm" est un logiciel libre ; vous pouvez le redistribuer ou le modifier suivant les termes de la GNU General Public License
;		telle que publie par la Free Software Foundation ; soit la version 3 de la licence, soit ( votre gr) toute version ultrieure.
;		Ce Script-Fu "Selection_Transformation_1.scm" est distribu dans l'espoir qu'il sera utile, mais SANS AUCUNE GARANTIE ; 
;		pas mme la garantie implicite de COMMERCIABILISABILIT ni d'ADQUATION  UN OBJECTIF PARTICULIER.
;		Consultez la GNU General Public License pour plus de dtails.
;		Vous devez avoir reu une copie de la GNU General Public License en mme temps que GIMP ; si ce n'est pas le cas, consultez <http://www.gnu.org/licenses>
;
;	Ce fichier Selection_Transformation_1.scm est dit avec Notepad++    http://notepad-plus-plus.org/
;
;
;
;
;
;
;	Version 2 du 20130610  Ajout Bounding Box.
;	Version 1 du 20130610  modifications condition de sortie de boucle, ajout ellipse incline.
;	Version 0.1 du 20130609
;
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;
;
;	Les slections sont transformes en polygones ou en toiles ou en ellipses inclines ou en rectangles aux dimensions de la "Bounding Box".
;	Pour les polygones, les sommets sont sur 1 ellipse inscrite dans le rectangle de la slection (bounding box).
;	Pour les toiles, les sommets sont sur 2 ellipses :
;		- Une ellipse extrieure inscrite dans le rectangle de la slection (bounding box).
;		- Une ellipse plus petite dfinie en pourcentage.
;	Pour les ellipses inclines :
;		- Dimension de l'ellipse = dimension de l'ellipse de la "bounding box".
;		- Angle d'inclinaison donn par le paramtre "Departure-Inclination / Angle / Depart-Inclinaison ".
;		- La prcision des chemins est fonction d'une trs grande approximation de la circonfrence.
;	Pour "Bounding Box" : Slection rectangulaire aux dimensions de la "Bounding Box".
;		
;	Chaque selection est sauvegard sous forme de chemin.
;
;
;	Selections are transformed into polygons or stars or ellipses inclined or "Bounding Box".
;	Polygons : The vertices are on one ellipse in the "bounding box".
;	Stars : The vertices of the star are on two ellipses :
;		- An outer ellipse in the "bounding box".
;		- A smaller ellipse defined by percentage.
;	Ellipse inclined : Dimensions = ellipse in the "bounding box" + Inclination angle
;
;	Each selection is saved as a path.
;
;
;	Accs sur l'image avec une slection active par :
;	Selection > Selection Transformation 1 ...
;
;	Access on the image with an active selection by :
;	Select > Selection Transformation 1 ...
;
;
;
;
;
;
;
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;
;
;	Ce script est adapt pour obtenir un petit chemin "Path_Inbetweener" afin d'utiliser "path-inbetweener" cr par Ofnuts, fichier path-inbetweener-0.0.py (test avec version v0.0: 2012-06-22 )
;	This script can create a small path "Path_Inbetweener" to use "path inbetweener" created by Ofnuts.
;		site :           http://gimp-path-tools.sourceforge.net/tools.shtml#path-inbetweener
;		tlchargement : http://sourceforge.net/projects/gimp-path-tools/files/scripts/path-inbetweener-0.0.py/download
;
;
;
;
;
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;
;
;


(define	
	(
		Selection_Transformation_1_samj
		image
		drawable
		Type_Polygone_Etoile_EllipseInclinee_BoundingBox
		Nombre_de_sommets
		Pourcentage_petite_ellipse
		Angle_Depart_ou_Rotation
		Tracer_la_selection
		Color_Pencil_1
		Pencil_1_Line_Thickness
		Color_intensity
		Save_Path_As_SVG
		Creer_Petit_Chemin
		Coeff_reduction


	)
	(let* 
		(

			(message (car (gimp-message-get-handler)))

			(2pi (* 2 3.14159265358979323846) )

			(Nom_de_la_brosse "Ma_Brosse_Spirale_samj")
			(The_shape_of_the_generated_brush 0) ; "Circle" "Square" "Diamond"
			(rayon_brosse (/ Pencil_1_Line_Thickness 2) )
			(sortie_boucle_tracer 0)


			(width (car (gimp-image-width image)))
			(height (car (gimp-image-height image)))

			(transparence (car (gimp-drawable-has-alpha drawable)))

			(Carateristiques_Selection (gimp-selection-bounds image))
			(Selection_Existe (car Carateristiques_Selection))
			(Selection_X1 (cadr Carateristiques_Selection))
			(Selection_Y1 (caddr Carateristiques_Selection))
			(Selection_X2 (cadr (cddr Carateristiques_Selection)))
			(Selection_Y2 (caddr (cddr Carateristiques_Selection)))

			(Centre_Ellipse_X (/ (+ Selection_X1 Selection_X2) 2) )
			(Centre_Ellipse_Y (/ (+ Selection_Y1 Selection_Y2) 2) )
			(a_Ellipse  (/ (- Selection_X2 Selection_X1) 2) )
			(b_Ellipse  (/ (- Selection_Y2 Selection_Y1) 2) )

			(Angle_polygone (/ 2pi Nombre_de_sommets) )
			(Angle_etoile (/ 3.14159265358979323846 Nombre_de_sommets) )

			(sortie_boucle 0)
			(nombre_de_boucle 0)
			(angle_en_cours 0)

			(Sommet_X 0)
			(Sommet_Y 0)

			(chemin_selection)
			(Points_chemin_selection)
			(Ajout_Points_chemin_selection)
			(Nombre_Points_chemin_selection 0)

			(filename "qwerty")

			(chemin_reduit)
			(Points_chemin_reduit)
			(Ajout_Points_chemin_reduit)

			(Sommet_X_chemin_reduit 0)
			(Sommet_Y_chemin_reduit 0)
			(X_ellipse 0)
			(Y_ellipse 0)
			(angle_inclinaison_en_degres Angle_Depart_ou_Rotation)




		)


	


		; pour image existante
		(gimp-undo-push-group-start image) 
		
		;; Start undo. Recommand par Saulgoode pour nouvelle image http://gimpchat.com/viewtopic.php?f=9&t=7342#p93780
		; (gimp-image-undo-disable image)

		; sauvegard le contexte.  Recommand par Saulgoode http://gimpchat.com/viewtopic.php?f=9&t=7342#p93780
		(gimp-context-push)

		;; slectionner la console erreurs pour envoyer un message
		(gimp-message-set-handler 2)		


;******************************************************************************************************
; 
;******************************************************************************************************

		; (gimp-message (string-append "Selection_Existe : " (number->string Selection_Existe) " X1-Y1/X2-Y2 : " (number->string Selection_X1)   "-"    (number->string Selection_Y1)  "/"  (number->string Selection_X2) "-"   (number->string Selection_Y2)                ) )	
		; (gimp-message (string-append " eX-eY : " (number->string Centre_Ellipse_X)   "-"    (number->string Centre_Ellipse_Y) ) )

		(if (= Selection_Existe 0)
			(begin
				(gimp-message "No selection! / Aucune selection!")
			)
			;else , une slection est active
			(begin

				(if (= Tracer_la_selection 1)
					(begin

						(gimp-context-set-foreground Color_Pencil_1)

						; crer une brosse
						(gimp-brush-new Nom_de_la_brosse)				

						(gimp-context-set-brush-size rayon_brosse )
						;;;(gimp-context-set-brush-default-size)
						(gimp-context-set-brush-aspect-ratio 1)
						(gimp-context-set-brush-angle 0)

						(gimp-context-set-brush Nom_de_la_brosse)

						(gimp-brush-set-shape Nom_de_la_brosse The_shape_of_the_generated_brush) ; forme

						(gimp-brush-set-radius Nom_de_la_brosse rayon_brosse ) ; rayon

						(gimp-brush-set-spikes Nom_de_la_brosse 2) ; pointes
						(gimp-brush-set-hardness Nom_de_la_brosse 1.0) ; duret 
						(gimp-brush-set-aspect-ratio Nom_de_la_brosse 1 ) ; proportions
						(gimp-brush-set-angle Nom_de_la_brosse 0) ; angle
						(gimp-brush-set-spacing Nom_de_la_brosse 1.0 ) ; espacement
					)
				)

				;transformation degrs radians
				(set! Angle_Depart_ou_Rotation (* (/ 2pi 360) Angle_Depart_ou_Rotation) )


				(set! sortie_boucle 0)
				(set! nombre_de_boucle -1)

				;******************************************************************************************************
				; Polygone
				;******************************************************************************************************


				(if (= Type_Polygone_Etoile_EllipseInclinee_BoundingBox 0)
					(begin

						(while (= sortie_boucle 0)
							(begin

								(set! nombre_de_boucle (+ nombre_de_boucle 1) )

								;condition de sortie
								(if (< nombre_de_boucle Nombre_de_sommets)
									(begin

										(set! angle_en_cours (+ Angle_Depart_ou_Rotation (* nombre_de_boucle Angle_polygone) ) )

										(set! Sommet_X (+ Centre_Ellipse_X (* a_Ellipse (cos angle_en_cours) ) )  )
										(set! Sommet_Y (+ Centre_Ellipse_Y (* b_Ellipse (sin angle_en_cours) ) )  )
										; (gimp-message (string-append " X-Y : " (number->string Sommet_X)   "-"   (number->string Sommet_Y) ) )
										
										; chemin rduit
										(set! Sommet_X_chemin_reduit (+ Centre_Ellipse_X (/ (* a_Ellipse (cos angle_en_cours) ) Coeff_reduction) )  )
										(set! Sommet_Y_chemin_reduit (+ Centre_Ellipse_Y (/ (* b_Ellipse (sin angle_en_cours) ) Coeff_reduction) )  )

										(if (= nombre_de_boucle 0)
											(begin
												(set! Points_chemin_selection (list Sommet_X Sommet_Y Sommet_X Sommet_Y Sommet_X Sommet_Y ) )
												(set! Nombre_Points_chemin_selection 6 )

												; chemin rduit
												(if (= Creer_Petit_Chemin 1)
													(begin
														(set! Points_chemin_reduit (list Sommet_X_chemin_reduit Sommet_Y_chemin_reduit Sommet_X_chemin_reduit Sommet_Y_chemin_reduit Sommet_X_chemin_reduit Sommet_Y_chemin_reduit ) )
													)
												)

											)
											;else
											(begin
												(set! Ajout_Points_chemin_selection (list Sommet_X Sommet_Y Sommet_X Sommet_Y Sommet_X Sommet_Y ) )
												(set! Points_chemin_selection (append Points_chemin_selection Ajout_Points_chemin_selection) )
												(set! Nombre_Points_chemin_selection (+ 6 Nombre_Points_chemin_selection ) )

												; chemin rduit
												(if (= Creer_Petit_Chemin 1)
													(begin
														(set! Ajout_Points_chemin_reduit (list Sommet_X_chemin_reduit Sommet_Y_chemin_reduit Sommet_X_chemin_reduit Sommet_Y_chemin_reduit Sommet_X_chemin_reduit Sommet_Y_chemin_reduit ) )
														(set! Points_chemin_reduit (append Points_chemin_reduit Ajout_Points_chemin_reduit) )
													)
												)

											)
										)

									)
									;else
									(begin
										(set! sortie_boucle 1)
									)
								)


							)
						)

						; sauvegarder la slection en cours comme chemin
						(plug-in-sel2path 1 image drawable)
						(gimp-item-set-name (car (gimp-image-get-active-vectors image) ) "Origine" )
						(gimp-selection-none image)


						; crer le chemin rduit
						(if (= Creer_Petit_Chemin 1)
							(begin
								(set! chemin_reduit (car (gimp-vectors-new image "Path_Inbetweener") ) )
								; (gimp-image-add-vectors image chemin_reduit 0)
								(gimp-image-insert-vectors image chemin_reduit 0 -1)
								(gimp-vectors-stroke-new-from-points
									chemin_reduit
									0
									Nombre_Points_chemin_selection
									(list->vector Points_chemin_reduit )
									1
								)
							)
						)


						; crer le nouveau chemin
						(set! chemin_selection (car (gimp-vectors-new image (strcat "Polygon_" (number->string Nombre_de_sommets) "_"  (number->string a_Ellipse) "_"  (number->string b_Ellipse)    )   ) )  ) 
						(gimp-image-insert-vectors image chemin_selection 0 -1)

						(gimp-vectors-stroke-new-from-points
							chemin_selection
							0
							Nombre_Points_chemin_selection
							(list->vector Points_chemin_selection )
							1
						)

						; sauvegarde du chemin en svg
						(if (= 1 Save_Path_As_SVG) 
							(begin
								(set! filename (string-append gimp-directory "/" (strcat "Polygon_" (number->string Nombre_de_sommets) "_"  (number->string a_Ellipse) "_"  (number->string b_Ellipse)   ".svg") ) )
								(gimp-vectors-export-to-file image filename (car (gimp-image-get-active-vectors image)) )
								(gimp-message (strcat "Save Path As : " filename ) )
							)
						)

						; transformer le chemin en slection
						(gimp-image-select-item image 0 (car (gimp-image-get-active-vectors image)))



					)
				)



				;******************************************************************************************************
				; toile
				;******************************************************************************************************


				(if (= Type_Polygone_Etoile_EllipseInclinee_BoundingBox 1)
					(begin

						(set! Pourcentage_petite_ellipse (/ Pourcentage_petite_ellipse 100) )

						(while (= sortie_boucle 0)
							(begin

								(set! nombre_de_boucle (+ nombre_de_boucle 1) )

								;condition de sortie
								(if (< nombre_de_boucle (* Nombre_de_sommets 2) )
									(begin

										(set! angle_en_cours (+ Angle_Depart_ou_Rotation (* nombre_de_boucle Angle_etoile) ) )

										(if (= (modulo nombre_de_boucle 2) 0)
											(begin

												(set! Sommet_X (+ Centre_Ellipse_X (* a_Ellipse (cos angle_en_cours) ) )  )
												(set! Sommet_Y (+ Centre_Ellipse_Y (* b_Ellipse (sin angle_en_cours) ) )  )
												; (gimp-message (string-append " X-Y : " (number->string Sommet_X)   "-"   (number->string Sommet_Y) ) )
												
												; chemin rduit
												(set! Sommet_X_chemin_reduit (+ Centre_Ellipse_X (/ (* a_Ellipse (cos angle_en_cours) ) Coeff_reduction) )  )
												(set! Sommet_Y_chemin_reduit (+ Centre_Ellipse_Y (/ (* b_Ellipse (sin angle_en_cours) ) Coeff_reduction) )  )
											)
											;else
											(begin
												(set! Sommet_X (+ Centre_Ellipse_X (* Pourcentage_petite_ellipse a_Ellipse (cos angle_en_cours) ) )  )
												(set! Sommet_Y (+ Centre_Ellipse_Y (* Pourcentage_petite_ellipse b_Ellipse (sin angle_en_cours) ) )  )
												; (gimp-message (string-append " X-Y : " (number->string Sommet_X)   "-"   (number->string Sommet_Y) ) )
												
												; chemin rduit
												(set! Sommet_X_chemin_reduit (+ Centre_Ellipse_X (/ (* Pourcentage_petite_ellipse a_Ellipse (cos angle_en_cours) ) Coeff_reduction) )  )
												(set! Sommet_Y_chemin_reduit (+ Centre_Ellipse_Y (/ (* Pourcentage_petite_ellipse b_Ellipse (sin angle_en_cours) ) Coeff_reduction) )  )
											)
										)

										(if (= nombre_de_boucle 0)
											(begin
												(set! Points_chemin_selection (list Sommet_X Sommet_Y Sommet_X Sommet_Y Sommet_X Sommet_Y ) )
												(set! Nombre_Points_chemin_selection 6 )

												; chemin rduit
												(if (= Creer_Petit_Chemin 1)
													(begin
														(set! Points_chemin_reduit (list Sommet_X_chemin_reduit Sommet_Y_chemin_reduit Sommet_X_chemin_reduit Sommet_Y_chemin_reduit Sommet_X_chemin_reduit Sommet_Y_chemin_reduit ) )
													)
												)

											)
											;else
											(begin
												(set! Ajout_Points_chemin_selection (list Sommet_X Sommet_Y Sommet_X Sommet_Y Sommet_X Sommet_Y ) )
												(set! Points_chemin_selection (append Points_chemin_selection Ajout_Points_chemin_selection) )
												(set! Nombre_Points_chemin_selection (+ 6 Nombre_Points_chemin_selection ) )

												; chemin rduit
												(if (= Creer_Petit_Chemin 1)
													(begin
														(set! Ajout_Points_chemin_reduit (list Sommet_X_chemin_reduit Sommet_Y_chemin_reduit Sommet_X_chemin_reduit Sommet_Y_chemin_reduit Sommet_X_chemin_reduit Sommet_Y_chemin_reduit ) )
														(set! Points_chemin_reduit (append Points_chemin_reduit Ajout_Points_chemin_reduit) )
													)
												)

											)
										)

									)
									;else
									(begin
										(set! sortie_boucle 1)
									)
								)


							)
						)

						; sauvegarder la slection en cours comme chemin
						(plug-in-sel2path 1 image drawable)
						(gimp-item-set-name (car (gimp-image-get-active-vectors image) ) "Origine" )
						(gimp-selection-none image)


						; crer le chemin rduit
						(if (= Creer_Petit_Chemin 1)
							(begin
								(set! chemin_reduit (car (gimp-vectors-new image "Path_Inbetweener") ) )
								; (gimp-image-add-vectors image chemin_reduit 0)
								(gimp-image-insert-vectors image chemin_reduit 0 -1)
								(gimp-vectors-stroke-new-from-points
									chemin_reduit
									0
									Nombre_Points_chemin_selection
									(list->vector Points_chemin_reduit )
									1
								)
							)
						)


						; crer le nouveau chemin
						(set! chemin_selection (car (gimp-vectors-new image (strcat "Star_" (number->string Nombre_de_sommets) "_"  (number->string a_Ellipse) "_"  (number->string b_Ellipse)    )   ) )  ) 
						(gimp-image-insert-vectors image chemin_selection 0 -1)

						(gimp-vectors-stroke-new-from-points
							chemin_selection
							0
							Nombre_Points_chemin_selection
							(list->vector Points_chemin_selection )
							1
						)

						; sauvegarde du chemin en svg
						(if (= 1 Save_Path_As_SVG) 
							(begin
								(set! filename (string-append gimp-directory "/" (strcat "Star_" (number->string Nombre_de_sommets) "_"  (number->string a_Ellipse) "_"  (number->string b_Ellipse)   ".svg") ) )
								(gimp-vectors-export-to-file image filename (car (gimp-image-get-active-vectors image)) )
								(gimp-message (strcat "Save Path As : " filename ) )
							)
						)

						; transformer le chemin en slection
						(gimp-image-select-item image 0 (car (gimp-image-get-active-vectors image)))



					)
				)





				;******************************************************************************************************
				; Ellipse incline
				;******************************************************************************************************


				(if (= Type_Polygone_Etoile_EllipseInclinee_BoundingBox 2)
					(begin
					
						(if (= (round (/ (* 3 (+ a_Ellipse b_Ellipse) ) 360) ) 0 )
							(begin
								(set! Nombre_de_sommets 180)
							)
						)
						
						(if (= (round (/ (* 3 (+ a_Ellipse b_Ellipse) ) 360) ) 1 )
							(begin
								(set! Nombre_de_sommets 360)
							)
						)

						(if (= (round (/ (* 3 (+ a_Ellipse b_Ellipse) ) 360) ) 2 )
							(begin
								(set! Nombre_de_sommets 720)
							)
						)

						(if (= (round (/ (* 3 (+ a_Ellipse b_Ellipse) ) 360) ) 3 )
							(begin
								(set! Nombre_de_sommets 1080)
							)
						)

						(if (= (round (/ (* 3 (+ a_Ellipse b_Ellipse) ) 360) ) 4 )
							(begin
								(set! Nombre_de_sommets 1440)
							)
						)

						(if (> (round (/ (* 3 (+ a_Ellipse b_Ellipse) ) 360) ) 4 )
							(begin
								(set! Nombre_de_sommets 1800)
							)
						)

						; (gimp-message (string-append " Nombre_de_sommets : " (number->string Nombre_de_sommets)   ) )

						(set! Angle_polygone (/ 2pi Nombre_de_sommets) )

						(while (= sortie_boucle 0)
							(begin

								(set! nombre_de_boucle (+ nombre_de_boucle 1) )

								;condition de sortie
								(if (< nombre_de_boucle Nombre_de_sommets)
									(begin

										(set! angle_en_cours (* nombre_de_boucle Angle_polygone) )

										; coordonnes d'une ellipse sans rotation
										(set! X_ellipse (* a_Ellipse (cos angle_en_cours) )  )
										(set! Y_ellipse (* b_Ellipse (sin angle_en_cours) )  )
										; rotation selon l'angle "Angle_Depart_ou_Rotation" et centrage
										(set! Sommet_X (+ Centre_Ellipse_X (- (* X_ellipse (cos Angle_Depart_ou_Rotation) ) (* Y_ellipse (sin Angle_Depart_ou_Rotation) )  ) )  )
										(set! Sommet_Y (+ Centre_Ellipse_Y (+ (* X_ellipse (sin Angle_Depart_ou_Rotation) ) (* Y_ellipse (cos Angle_Depart_ou_Rotation) )  ) )  )
										; (gimp-message (string-append " X-Y : " (number->string Sommet_X)   "-"   (number->string Sommet_Y) ) )
										
										; chemin rduit
										(set! Sommet_X_chemin_reduit (+ Centre_Ellipse_X (/  (- (* X_ellipse (cos Angle_Depart_ou_Rotation) ) (* Y_ellipse (sin Angle_Depart_ou_Rotation) )  ) Coeff_reduction) )  )
										(set! Sommet_Y_chemin_reduit (+ Centre_Ellipse_Y (/  (+ (* X_ellipse (sin Angle_Depart_ou_Rotation) ) (* Y_ellipse (cos Angle_Depart_ou_Rotation) )  ) Coeff_reduction) )  )

										(if (= nombre_de_boucle 0)
											(begin
												(set! Points_chemin_selection (list Sommet_X Sommet_Y Sommet_X Sommet_Y Sommet_X Sommet_Y ) )
												(set! Nombre_Points_chemin_selection 6 )

												; chemin rduit
												(if (= Creer_Petit_Chemin 1)
													(begin
														(set! Points_chemin_reduit (list Sommet_X_chemin_reduit Sommet_Y_chemin_reduit Sommet_X_chemin_reduit Sommet_Y_chemin_reduit Sommet_X_chemin_reduit Sommet_Y_chemin_reduit ) )
													)
												)

											)
											;else
											(begin
												(set! Ajout_Points_chemin_selection (list Sommet_X Sommet_Y Sommet_X Sommet_Y Sommet_X Sommet_Y ) )
												(set! Points_chemin_selection (append Points_chemin_selection Ajout_Points_chemin_selection) )
												(set! Nombre_Points_chemin_selection (+ 6 Nombre_Points_chemin_selection ) )

												; chemin rduit
												(if (= Creer_Petit_Chemin 1)
													(begin
														(set! Ajout_Points_chemin_reduit (list Sommet_X_chemin_reduit Sommet_Y_chemin_reduit Sommet_X_chemin_reduit Sommet_Y_chemin_reduit Sommet_X_chemin_reduit Sommet_Y_chemin_reduit ) )
														(set! Points_chemin_reduit (append Points_chemin_reduit Ajout_Points_chemin_reduit) )
													)
												)

											)
										)

									)
									;else
									(begin
										(set! sortie_boucle 1)
									)
								)


							)
						)

						; sauvegarder la slection en cours comme chemin
						(plug-in-sel2path 1 image drawable)
						(gimp-item-set-name (car (gimp-image-get-active-vectors image) ) "Origine" )
						(gimp-selection-none image)


						; crer le chemin rduit
						(if (= Creer_Petit_Chemin 1)
							(begin
								(set! chemin_reduit (car (gimp-vectors-new image "Path_Inbetweener") ) )
								; (gimp-image-add-vectors image chemin_reduit 0)
								(gimp-image-insert-vectors image chemin_reduit 0 -1)
								(gimp-vectors-stroke-new-from-points
									chemin_reduit
									0
									Nombre_Points_chemin_selection
									(list->vector Points_chemin_reduit )
									1
								)
							)
						)


						; crer le nouveau chemin
						(set! chemin_selection (car (gimp-vectors-new image (strcat "Ellipse_Inclined_" (number->string angle_inclinaison_en_degres) "_"  (number->string a_Ellipse) "_"  (number->string b_Ellipse)    )   ) )  ) 
						(gimp-image-insert-vectors image chemin_selection 0 -1)

						(gimp-vectors-stroke-new-from-points
							chemin_selection
							0
							Nombre_Points_chemin_selection
							(list->vector Points_chemin_selection )
							1
						)

						; sauvegarde du chemin en svg
						(if (= 1 Save_Path_As_SVG) 
							(begin
								(set! filename (string-append gimp-directory "/" (strcat "Ellipse_Inclined_" (number->string angle_inclinaison_en_degres) "_"  (number->string a_Ellipse) "_"  (number->string b_Ellipse)   ".svg") ) )
								(gimp-vectors-export-to-file image filename (car (gimp-image-get-active-vectors image)) )
								(gimp-message (strcat "Save Path As : " filename ) )
							)
						)

						; transformer le chemin en slection
						(gimp-image-select-item image 0 (car (gimp-image-get-active-vectors image)))



					)
				)




				;******************************************************************************************************
				; Bounding Box
				;******************************************************************************************************


				(if (= Type_Polygone_Etoile_EllipseInclinee_BoundingBox 3)
					(begin

						;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
						(set! Points_chemin_selection (list Selection_X1 Selection_Y1 Selection_X1 Selection_Y1 Selection_X1 Selection_Y1 ) )
						(set! Ajout_Points_chemin_selection (list Selection_X2 Selection_Y1 Selection_X2 Selection_Y1 Selection_X2 Selection_Y1 ) )
						(set! Points_chemin_selection (append Points_chemin_selection Ajout_Points_chemin_selection) )
						(set! Ajout_Points_chemin_selection (list Selection_X2 Selection_Y2 Selection_X2 Selection_Y2 Selection_X2 Selection_Y2 ) )
						(set! Points_chemin_selection (append Points_chemin_selection Ajout_Points_chemin_selection) )
						(set! Ajout_Points_chemin_selection (list Selection_X1 Selection_Y2 Selection_X1 Selection_Y2 Selection_X1 Selection_Y2 ) )
						(set! Points_chemin_selection (append Points_chemin_selection Ajout_Points_chemin_selection) )
						(set! Nombre_Points_chemin_selection 24 )

						; chemin rduit
						(if (= Creer_Petit_Chemin 1)
							(begin
								(set! Sommet_X_chemin_reduit (- Centre_Ellipse_X (/ a_Ellipse Coeff_reduction) )  )
								(set! Sommet_Y_chemin_reduit (- Centre_Ellipse_Y (/ b_Ellipse Coeff_reduction) )  )
								(set! Points_chemin_reduit (list Sommet_X_chemin_reduit Sommet_Y_chemin_reduit Sommet_X_chemin_reduit Sommet_Y_chemin_reduit Sommet_X_chemin_reduit Sommet_Y_chemin_reduit ) )
								(set! Sommet_X_chemin_reduit (+ Centre_Ellipse_X (/ a_Ellipse Coeff_reduction) )  )
								(set! Sommet_Y_chemin_reduit (- Centre_Ellipse_Y (/ b_Ellipse Coeff_reduction) )  )
								(set! Ajout_Points_chemin_reduit (list Sommet_X_chemin_reduit Sommet_Y_chemin_reduit Sommet_X_chemin_reduit Sommet_Y_chemin_reduit Sommet_X_chemin_reduit Sommet_Y_chemin_reduit ) )
								(set! Points_chemin_reduit (append Points_chemin_reduit Ajout_Points_chemin_reduit) )
								(set! Sommet_X_chemin_reduit (+ Centre_Ellipse_X (/ a_Ellipse Coeff_reduction) )  )
								(set! Sommet_Y_chemin_reduit (+ Centre_Ellipse_Y (/ b_Ellipse Coeff_reduction) )  )
								(set! Ajout_Points_chemin_reduit (list Sommet_X_chemin_reduit Sommet_Y_chemin_reduit Sommet_X_chemin_reduit Sommet_Y_chemin_reduit Sommet_X_chemin_reduit Sommet_Y_chemin_reduit ) )
								(set! Points_chemin_reduit (append Points_chemin_reduit Ajout_Points_chemin_reduit) )
								(set! Sommet_X_chemin_reduit (- Centre_Ellipse_X (/ a_Ellipse Coeff_reduction) )  )
								(set! Sommet_Y_chemin_reduit (+ Centre_Ellipse_Y (/ b_Ellipse Coeff_reduction) )  )
								(set! Ajout_Points_chemin_reduit (list Sommet_X_chemin_reduit Sommet_Y_chemin_reduit Sommet_X_chemin_reduit Sommet_Y_chemin_reduit Sommet_X_chemin_reduit Sommet_Y_chemin_reduit ) )
								(set! Points_chemin_reduit (append Points_chemin_reduit Ajout_Points_chemin_reduit) )
							)
						)





						;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

						; sauvegarder la slection en cours comme chemin
						(plug-in-sel2path 1 image drawable)
						(gimp-item-set-name (car (gimp-image-get-active-vectors image) ) "Origine" )
						(gimp-selection-none image)


						; crer le chemin rduit
						(if (= Creer_Petit_Chemin 1)
							(begin
								(set! chemin_reduit (car (gimp-vectors-new image "Path_Inbetweener") ) )
								; (gimp-image-add-vectors image chemin_reduit 0)
								(gimp-image-insert-vectors image chemin_reduit 0 -1)
								(gimp-vectors-stroke-new-from-points
									chemin_reduit
									0
									Nombre_Points_chemin_selection
									(list->vector Points_chemin_reduit )
									1
								)
							)
						)


						; crer le nouveau chemin
						(set! chemin_selection (car (gimp-vectors-new image (strcat "BoundingBox_"  (number->string (* 2 a_Ellipse) ) "_"  (number->string (* 2 b_Ellipse) )    )   ) )  ) 
						(gimp-image-insert-vectors image chemin_selection 0 -1)

						(gimp-vectors-stroke-new-from-points
							chemin_selection
							0
							Nombre_Points_chemin_selection
							(list->vector Points_chemin_selection )
							1
						)

						; sauvegarde du chemin en svg
						(if (= 1 Save_Path_As_SVG) 
							(begin
								(set! filename (string-append gimp-directory "/" (strcat "BoundingBox_"  (number->string (* 2 a_Ellipse) ) "_"  (number->string (* 2 b_Ellipse) )   ".svg") ) )
								(gimp-vectors-export-to-file image filename (car (gimp-image-get-active-vectors image)) )
								(gimp-message (strcat "Save Path As : " filename ) )
							)
						)

						; transformer le chemin en slection
						(gimp-image-select-item image 0 (car (gimp-image-get-active-vectors image)))



					)
				)










				;******************************************************************************************************
				; tracer la slection
				;******************************************************************************************************



				(if (= Tracer_la_selection 1)
					(begin

						(gimp-selection-none image)

						(set! sortie_boucle_tracer Color_intensity)

						(while (> sortie_boucle_tracer 0)
							(begin
								(gimp-edit-stroke-vectors drawable (car (gimp-image-get-active-vectors image) ) )
								(set! sortie_boucle_tracer (- sortie_boucle_tracer 1) )
							)
						)

						(gimp-brush-delete Nom_de_la_brosse)

						; transformer le chemin en slection
						(gimp-image-select-item image 0 (car (gimp-image-get-active-vectors image)))


					)
				)


			)
		)


;******************************************************************************************************
; 
;******************************************************************************************************

		;; rtablir le mode message
		(gimp-message-set-handler message)

		; restituer l'ancien contexte.  Recommand par Saulgoode http://gimpchat.com/viewtopic.php?f=9&t=7342#p93780
		(gimp-context-pop)

		; End undo. Recommand par Saulgoode pour nouvelle image http://gimpchat.com/viewtopic.php?f=9&t=7342#p93780
		;(gimp-image-undo-enable image)

		; pour image existante
		(gimp-undo-push-group-end image)

		(gimp-displays-flush)

	)
)





; Nouvelle mthode recommand par Saulgoode http://gimpchat.com/viewtopic.php?f=9&t=7342#p93780
(script-fu-register "Selection_Transformation_1_samj"
                    _"Selection Transformation 1 ..."
                    "Selection Transformation 1 ..."
                    "samj"
                    "samj"
                    "20130609"
                    "*"
                    SF-IMAGE    "Image"     0
                    SF-DRAWABLE "Drawable"  0
					SF-OPTION "Type " '("Polygon / Polygone" "Star / Etoile" "Ellipse inclined / Ellipse inclinee" "Bounding Box")
					SF-ADJUSTMENT "Number of vertices / Nombre de sommets " '(4 3 90 1 5 0 1)
					SF-ADJUSTMENT "% Small ellipse (star) / % Petite ellipse (etoile) " '(50 0 100 1 5 4 1)
					SF-ADJUSTMENT "Departure-Inclination / Angle / Depart-Inclinaison " '(0 0 360 1 5 4 1)
					SF-TOGGLE "Stroke selection / Tracer la selection " FALSE
					SF-COLOR "Color Pencil 1 " '(0 0 0)
					SF-ADJUSTMENT "Pencil 1 - Line Thickness " '(2 1 40 1 5 0 1)
					SF-ADJUSTMENT "Color intensity " '(3 1 10 1 5 0 1)
					SF-TOGGLE "Save Path As SVG " FALSE
					SF-TOGGLE "Create Path__Inbetweener " FALSE
					SF-ADJUSTMENT "Reduction Coefficient To Create Path__Inbetweener " '(10 2 12 5 4 1)			


)

; Nouvelle mthode recommand par Saulgoode http://gimpchat.com/viewtopic.php?f=9&t=7342#p93780
(script-fu-menu-register "Selection_Transformation_1_samj"
					_"<Image>/Select/Modify"
)




;; FIN





