; Dbut du script-fu delaem_tehnologicheskoe_izobrazhenie_gimp_2_8.scm
;
; Accs par :   Fichier > Crer > Motifs > Delaem Tehnologicheskoe Izobrazhenie...
;               File > Create > Patterns > Delaem Tehnologicheskoe Izobrazhenie...
;
;                __________________________________________________________
; 
;
; script-fu adapt du didacticiel  http://www.progimp.ru/articles/delaem_tehnologicheskoe_izobrazhenie/
; Merci  l'auteur.
;
; 
;
; Licence GNU/GPL
;
; --------------------------------------------------------------------
; dit avec Notepad++    http://notepad-plus-plus.org/
;
; version 1.0 par samj (  http://www.aljacom.com/~gimp       http://samjcreations.blogspot.com  ) 5 juin 2012
;
; --------------------------------------------------------------------
;
;


(define (
				delaem_tehnologicheskoe_izobrazhenie
				width
				height
				seed_plasma
				turbulence_plasma
				cote_carre_en_pixels
				curve_point_0
				curve_point_31
				curve_point_63
				curve_point_95
				curve_point_127
				curve_point_159
				curve_point_191
				curve_point_223
				curve_point_255
				tileable
		)
		
	(let*
		(
			; affectation des variables		
	
			; mmoriser les couleurs PP et AP
			(old-fg (car (gimp-context-get-foreground)))
			(old-bg (car (gimp-context-get-background)))
			
			; crer une nouvelle image rgb
			(img (car (gimp-image-new width height 0)))
			
			;calque_fond
			(calque_fond)
			
			; array courbe couleurs
			(array_couleurs (cons-array 18 'byte))			
		
			
		)

	;; Start undo group.
	(gimp-image-undo-group-start img)		
		

		
		

; calque_fond*********************************************************************************
	


	; crer calque_fond
	(set! calque_fond (car (gimp-layer-new img width height 1 "calque_fond" 100 0)))	
	
	; ajouter le calque calque_fond
	(gimp-image-insert-layer img calque_fond 0 -1)

	; plasma
	(plug-in-plasma 
		1 					; run-mode 
		img 				; image 
		calque_fond 		; drawable 
		seed_plasma 		; seed 
		turbulence_plasma 	; turbulence de 0.1  7.0
	)

	; pixelize
	(plug-in-pixelize2 
		1						; run-mode 
		img						; image 
		calque_fond				; drawable 
		cote_carre_en_pixels	; pixel-width 
		cote_carre_en_pixels	; pixel-height
	)
	

	; repoussage d'aprs une carte
	(plug-in-bump-map-tiled 
		1						; run-mode 
		img						; image 
		calque_fond				; drawable 
		calque_fond				; bumpmap 
		220.0					; azimuth 
		7.0						; elevation 
		1						; depth 
		0						; xofs 
		0						; yofs 
		0						; waterlevel 
		0						; ambient 
		1						; compensate 
		0						; invert 
		0						; type
	)
	

	; contour
	(plug-in-edge 
		1						; run-mode 
		img						; image 
		calque_fond				; drawable 
		2.0						; amount 
		2						; wrapmode 
		3						; edgemode
	)

	
	;; courbe ajustement des couleurs finales
	
	
	; procdure set_pt pour remplissage array de Michael Schalla
	(define (set-pt array_couleurs index x y)
		(begin
			(aset array_couleurs (* index 2) x)
			(aset array_couleurs (+ (* index 2) 1) y)
		)
	)

	; 9 points de la courbe array_couleurs
	(set-pt array_couleurs 0 0 curve_point_0)
	(set-pt array_couleurs 1 31 curve_point_31)
	(set-pt array_couleurs 2 63 curve_point_63)
	(set-pt array_couleurs 3 95 curve_point_95)
	(set-pt array_couleurs 4 127 curve_point_127)
	(set-pt array_couleurs 5 159 curve_point_159)
	(set-pt array_couleurs 6 191 curve_point_191)
	(set-pt array_couleurs 7 223 curve_point_223)
	(set-pt array_couleurs 8 255 curve_point_255)

	
	; appliquer la courbe
	(gimp-curves-spline 
				calque_fond 	; drawable 
				0 				; channel 
				18 				; num-points 
				array_couleurs 	; control-pts
	)

	
	; rendre le motif raccordable
	(if	
		(= tileable TRUE) 
			; appel du greffon 
			(plug-in-make-seamless 1 img  calque_fond)
	)

	
	
;*******************************************************************************************
	
	; restaurer PP et AP
	(gimp-context-set-foreground  old-fg)
	(gimp-context-set-background old-bg)

	; ne rien slectionner
	(gimp-selection-none img)
	
	; afficher l'image
	(gimp-display-new img)

	; End undo group.
	(gimp-image-undo-group-end img)	

	)
		
)



(script-fu-register
	"delaem_tehnologicheskoe_izobrazhenie"
	"<Image>/File/Create/Patterns/Delaem Tehnologicheskoe Izobrazhenie..."
	"Motif technologique"
	"samj"
	"samj"
	"2010-06-05"
	""
	SF-ADJUSTMENT "Largeur motif / Width (pixels)"  '(500 64 4096 8 64 0 1) ; pixels
	SF-ADJUSTMENT "Hauteur motif / Height (pixels)"  '(500 64 4096 8 64 0 1) ; pixels
	SF-ADJUSTMENT "Seed (Plasma)"  '(0 0 4096 1 10 0 1) ; seed
	SF-ADJUSTMENT "Turbulence (Plasma)"  '(1.0 0.1 7 0.1 1 1 1) ; turbulence de 0.1  7.0
	SF-ADJUSTMENT "Cote carre / Side of the square (pixels)"  '(10 4 64 1 8 0 1) ; pixels	
	SF-ADJUSTMENT "Couleurs : Courbe / Curve (0)"  '(0 0 255 1 10 0 0) ; couleurs 0
	SF-ADJUSTMENT "Couleurs : Courbe / Curve (31)"  '(31 0 255 1 10 0 0) ; couleurs 31
	SF-ADJUSTMENT "Couleurs : Courbe / Curve (63)"  '(63 0 255 1 10 0 0) ; couleurs 63
	SF-ADJUSTMENT "Couleurs : Courbe / Curve (95)"  '(95 0 255 1 10 0 0) ; couleurs 95
	SF-ADJUSTMENT "Couleurs : Courbe / Curve (127)"  '(127 0 255 1 10 0 0) ; couleurs 127 
	SF-ADJUSTMENT "Couleurs : Courbe / Curve (159)"  '(159 0 255 1 10 0 0) ; couleurs 159 
	SF-ADJUSTMENT "Couleurs : Courbe / Curve (191)"  '(191 0 255 1 10 0 0) ; couleurs 191
	SF-ADJUSTMENT "Couleurs : Courbe / Curve (223)"  '(223 0 255 1 10 0 0) ; couleurs 223
	SF-ADJUSTMENT "Couleurs : Courbe / Curve (255)"  '(255 0 255 1 10 0 0) ; couleurs 255
	SF-TOGGLE	"Rendre raccordable / Tileable" FALSE
)


; FIN du script