; Dbut du script-fu dents_de_scie_2_8.scm
;
; Accs sur l'image par :   Filtres > Artistiques > Dents de scie...
;                           Filters > Artistic > Dents de scie...
;
; Licence GNU/GPL
;
; Ce script-fu utilise G'MIC pour Gimp   http://gmic.sourceforge.net/gimp.shtml
; Ce script-fu est lent.
;
; version 1.0 samj ( http://samjcreations.blogspot.ca/ ) le 21 septembre 2012
; 
; 
; fichier dents_de_scie_2_8.scm dit avec Notepad++    http://notepad-plus-plus.org/
;
; discussion http://www.gimpchat.com/viewtopic.php?f=15&t=5317
;
;

(define 
	(
		dents_de_scie_2_8
		img
		drawable
		Dimension_echantillon
		Type_de_trait
		Colorisation
		Couleur
		Degrade
	)

	;; dbut groupe undo
	(gimp-image-undo-group-start img)

	; passer en rvb si couleurs indexes
	(if 
		(= (car (gimp-drawable-is-indexed drawable)) TRUE)	
			;; convertir en rvb
			(gimp-image-convert-rgb img)
	)

	; passer en rvb si couleurs en niveaux de gris
	(if 
		(= (car (gimp-drawable-is-gray drawable)) TRUE)	
			;; convertir en rvb
			(gimp-image-convert-rgb img)
	)	
	
	
	(let* 
		(
			
			; mmoriser les couleurs PP et AP
			(old-fg (car (gimp-context-get-foreground)))
			(old-bg (car (gimp-context-get-background)))			
			
			(layer_traits_de_couleurs_avec_gmic 0)
			(layer_dents_de_scie_colorees_avec_gmic 0)
			(layer_colorisation 0)
			(largeur)
			(hauteur)
			(indexh)
			(indexv)
			(width)
			(height)
			(active-selection 0)
			(selection_en_cours 0)
	
		) 

	; mmoriser la slection
	(if (= (car (gimp-selection-is-empty img)) FALSE)
		(begin 
			(set! selection_en_cours 1)
			(set! active-selection (car (gimp-selection-save img)))
		)
	)

		
		
; layer_traits_de_couleurs_avec_gmic*************************************************************


	;; ajouter le calque
	(set! layer_traits_de_couleurs_avec_gmic (car (gimp-layer-new-from-visible img img "layer_traits_de_couleurs_avec_gmic")))

	;; activer le calque
	(gimp-image-insert-layer img layer_traits_de_couleurs_avec_gmic 0 -1)

	;; Appel de G'MIC.
	(plug-in-gmic 1 img layer_traits_de_couleurs_avec_gmic 1
		(string-append
			"-v - " ; To have a silent output. Remove it to display errors from the G'MIC interpreter on stderr.
			"-remove_opacity -gimp_painting 5,2.5,1.5,50,1 -gimp_morpho 5,5,0,0,0,0"
		)
	)	
 

 
 
; layer_dents_de_scie_colorees_avec_gmic*************************************************************


	;; ajouter le calque
	(set! layer_dents_de_scie_colorees_avec_gmic (car (gimp-layer-new-from-visible img img "layer_dents_de_scie_colorees_avec_gmic")))

	;; activer le calque
	(gimp-image-insert-layer img layer_dents_de_scie_colorees_avec_gmic 0 -1)
	
	; dimensions du calque
	(set! width (car (gimp-drawable-width layer_dents_de_scie_colorees_avec_gmic)))
	(set! height (car (gimp-drawable-height layer_dents_de_scie_colorees_avec_gmic)))

	
	;; boucle pour appliquer des waves
	(set! largeur 0)
	(set! hauteur 0)
	(set! indexh 0)
	(set! indexv 0)
	
	(while (< hauteur height)

				(while (< largeur width)
	
						; slectionner un rectangle
						(gimp-image-select-rectangle 
							img			; image 
							0			; operation 
							largeur		; x 
							hauteur		; y 
							Dimension_echantillon	; width 
							Dimension_echantillon	; height
						)
						
						
						(if (= Type_de_trait 0)
							
							(begin
							
								;; Appel de G'MIC.
								(plug-in-gmic 1 img layer_dents_de_scie_colorees_avec_gmic 1
									(string-append
										"-v - " ; To have a silent output. Remove it to display errors from the G'MIC interpreter on stderr.
										"-wave 3.01,1.96,50,50"
									)		
								)
								
							)
						)
						

						;;;;;;;;;;;
							

						(if (= Type_de_trait 1)
							
							(begin
								; appliquer waves
								(if
									(and (= 0 (modulo indexh 2)) (= 0 (modulo indexv 2))  )
										(begin 
						
												;; Appel de G'MIC.
												(plug-in-gmic 1 img layer_dents_de_scie_colorees_avec_gmic 1
													(string-append
														"-v - " ; To have a silent output. Remove it to display errors from the G'MIC interpreter on stderr.
														"-wave 3.01,1.96,100,100"
													)		
												)
										)
								)


								(if
									(and (= 1 (modulo indexh 2)) (= 0 (modulo indexv 2))  )
										(begin 
						
												;; Appel de G'MIC.
												(plug-in-gmic 1 img layer_dents_de_scie_colorees_avec_gmic 1
													(string-append
														"-v - " ; To have a silent output. Remove it to display errors from the G'MIC interpreter on stderr.
														"-wave 3.01,1.96,0,0"
													)		
												)
										)
								)			

								(if
									(and (= 0 (modulo indexh 2)) (= 1 (modulo indexv 2))  )
										(begin 
						
												;; Appel de G'MIC.
												(plug-in-gmic 1 img layer_dents_de_scie_colorees_avec_gmic 1
													(string-append
														"-v - " ; To have a silent output. Remove it to display errors from the G'MIC interpreter on stderr.
														"-wave 3.01,1.96,0,0"
													)		
												)
										)
								)


								(if
									(and (= 1 (modulo indexh 2)) (= 1 (modulo indexv 2))  )
										(begin 
						
												;; Appel de G'MIC.
												(plug-in-gmic 1 img layer_dents_de_scie_colorees_avec_gmic 1
													(string-append
														"-v - " ; To have a silent output. Remove it to display errors from the G'MIC interpreter on stderr.
														"-wave 3.01,1.96,100,100"
													)		
												)
										)
								)
									
							)
									
						)
		
						;;;;;;;;;;;
							; ne rien slectionner
							(gimp-selection-none img)
							
							(set! indexh (+ indexh 1))
							
							(set! largeur (+ largeur Dimension_echantillon))
								
					)
			
			(set! indexv (+ indexv 1))
			
			(set! hauteur (+ hauteur Dimension_echantillon))
			
			(set! indexh 0) 
 
			(set! largeur 0)

	)

	
	
	
; layer_colorisation*************************************************************

	(if (> Colorisation 0)
		
		(begin	
		
			;; ajouter le calque
			(set! layer_colorisation (car (gimp-layer-new-from-visible img img "layer_colorisation")))

			;; activer le calque
			(gimp-image-insert-layer img layer_colorisation 0 -1)

			; mettre en mode couleur
			(gimp-layer-set-mode layer_colorisation 13)
			
			; remplir couleur
			(if (= Colorisation 1)
				
				(begin
				
					; modifier couleur de premier plan
					(gimp-context-set-foreground Couleur)	
				
					; remplir de couleur PP
					(gimp-drawable-fill layer_colorisation 0)
					
				)
					
			)


			; remplir dgrad
			(if (= Colorisation 2)
				
				(begin
				
					; modifier couleur de premier plan
					(gimp-context-set-foreground '(0 0 0))
					
					; modifier couleur d'arrire plan
					(gimp-context-set-background '(255 255 255))	
					
					; slectionner le dgrad choisi
					(gimp-context-set-gradient Degrade)	
					
					; appliquer un dgrad sur layer_colorisation
					(gimp-edit-blend 
						layer_colorisation 
						3 						; MODE
						0 
						0 						; GRADIENT-LINEAR
						100 
						0 
						0 
						FALSE 
						FALSE 
						0 
						0 
						FALSE 
						0						; x1 
						height					; y1 
						width					; x2
						0 						; y2
					)
					
				)
					
			)

			
		
		)
		
	)
	
	
	
	; restituer la slection
	(if (= selection_en_cours 1)
		(gimp-image-select-item img 2 active-selection)
	)
	
	
	
;*******************************************************************************************
	
	; restaurer PP et AP
	(gimp-context-set-foreground  old-fg)
	(gimp-context-set-background old-bg)	
	

	
    ;; fin groupe undo
	(gimp-image-undo-group-end img)
	
    ;; afficher
	(gimp-displays-flush)
	
	
	)
)

(script-fu-register
	"dents_de_scie_2_8"
	"<Image>/Filters/Artistic/Dents de scie..."
	"Dents de scie avec G'MIC"
	"samj"
	"samj"
	"2012-09-21"
	"*"
	SF-IMAGE      "Image"		0
	SF-DRAWABLE   "Drawable"	0
	SF-ADJUSTMENT "Dimension echantillon / Sample size (pixels)"  '(40 20 80 1 10 0 1) ; pixels
	SF-OPTION "Type de trait / Linetype" '(" Regulier / Regular " " Alterne / Alternate ") ; Options du type de trait
	SF-OPTION "Colorisation / Colorization" '(" Sans / Without " " Couleur / Color " " Degrade / Gradient ") ; Options du type de trait
	SF-COLOR "Couleur / Color " '(195 151 31) ; brun
	SF-GRADIENT "Degrade / Gradient " "Golden"  ; Degrad

)

; FIN script-fu
