; Dbut du script-fu gradient_generator_1_or_2_colors_gimp_2_8.scm
;
; Accs par :   Fichier > Crer > Gradients > Gradient generator 1-2 colors...
;               File > Create > Gradients > Gradient generator 1-2 colors...
;
;                __________________________________________________________
; 
; 
; 
;
;			Exemple de dgrad cr par ce script-fu :
;
;			GIMP Gradient
;			Name: Gradient 1-2 colors
;			4
;			0.000000 0.125000 0.250000 0.000000 0.000000 0.000000 0.560000 1.000000 1.000000 1.000000 0.750000 0 0 0 0
;			0.250000 0.375000 0.500000 0.000000 0.000000 0.000000 0.530000 1.000000 1.000000 1.000000 0.500000 0 0 0 0
;			0.500000 0.625000 0.750000 0.000000 0.000000 0.000000 0.270000 0.807843 0.807843 0.807843 0.780000 0 0 0 0
;			0.750000 0.875000 1.000000 0.345098 0.345098 0.345098 0.480000 0.811765 0.811765 0.811765 0.690000 0 0 0 0
;
;                __________________________________________________________
; 
;
;
;
;
; Licence GNU/GPL
;
; --------------------------------------------------------------------
; version 1.0 par samj (www.aljacom.com/~gimp) 2010/12/20
; version 2.0 par samj (www.aljacom.com/~gimp) 2010/12/20 adaptation pour gimp 2.7.2
;
; --------------------------------------------------------------------
;
;


(define (
				gradient_generator_1_or_2_colors
				Nb_segments
				gradient_name
				couleur
				clair
				complementaire
		)
		
	(let*
		(
			; affectation des variables		

			; dimensions de l'image
			(width 400)
			(height 400)
			
			; mmoriser les couleurs PP et AP
			(old-fg (car (gimp-context-get-foreground)))
			(old-bg (car (gimp-context-get-background)))
			
			; mmoriser le dgrad actif
			;(old_gradient (car (gimp-context-get-gradient)))
			
			; crer une nouvelle image rgb
			(img (car (gimp-image-new width height 0)))
			
			;calque_fond
			(calque_fond)
			
			; degrade
			(degrade)
			
			; variable segment
			(segment)

			; nombre alatoire
			(lightness)
			
		
			
		)

	;; Start undo group.
	(gimp-image-undo-group-start img)		
		

		
		

; calque_fond*********************************************************************************
	


	; crer calque_fond
	(set! calque_fond (car (gimp-layer-new img width height 1 "calque_fond" 100 0)))	
	
	; ajouter le calque calque_fond
	(gimp-image-insert-layer img calque_fond 0 -1)


	
	
	
; paramtres du dgrad *******************************************************************************		

	; crer le dgrad degrade
	(set! degrade (car (gimp-gradient-new gradient_name)))
	
	; rendre degrade actif
	(gimp-context-set-gradient degrade)
	
	; diviser le dgrad en x segments gaux
	(gimp-gradient-segment-range-split-uniform 
				degrade ; name 
				0 ; start-segment	The index of the first segment to operate on (start-segment >= 0)
				(- Nb_segments 1) ; end-segment	The index of the last segment to operate on. If negative, the selection will extend to the end of the string.
				Nb_segments ; split-parts	The number of uniform divisions to split each segment to (2 <= split-parts <= 1024)
	)

	; positionner segment
	(set! segment -1)

	
	; boucle pour crer les segments
	(while 
		(< segment (- Nb_segments 1)) 	
	
				;______________________________ 
	
				(set! segment (+ 1 segment))
				
				; modifier couleur pp
				(gimp-context-set-foreground couleur)
				
				; remplir de la couleur de pp
				(gimp-drawable-fill calque_fond 0)
				
				; dfinir la nouvelle luminosit
				(set! lightness (- (random 200) 100))

				; appliquer clair
				(if 
					(= clair TRUE)
						(begin
							; dfinir la nouvelle luminosit
							(set! lightness (random 100))				
						)
				)
				
				; nouvelle couleur modifie en luminosit
				(gimp-hue-saturation calque_fond 0 0 lightness 0)
	
				; segment partie gauche
				(gimp-gradient-segment-set-left-color 
							degrade ; name 
							segment ; segment	The index of the segment within the gradient (segment >= 0)
							(car (gimp-image-pick-color img calque_fond 10 10 FALSE FALSE 0)) ; color	 The color to set
							(round (+ 10 (random 90))) ; opacity
				)


				; modifier couleur pp
				(gimp-context-set-foreground couleur)
				
				; remplir de la couleur de pp
				(gimp-drawable-fill calque_fond 0)
				
				; appliquer couleur complmentaire
				(if 
					(= complementaire TRUE)
						(begin
							; inverser
							(gimp-invert calque_fond)					
						)
				)					

				
				; dfinir la nouvelle luminosit
				(set! lightness (- (random 200) 100))


				; appliquer clair
				(if 
					(= clair TRUE)
						(begin
							; dfinir la nouvelle luminosit
							(set! lightness (random 100))				
						)
				)

				
				; nouvelle couleur modifie en luminosit
				(gimp-hue-saturation calque_fond 0 0 lightness 0)
				
				; segment partie droite
				(gimp-gradient-segment-set-right-color 
							degrade ; name 
							segment ; segment 
							(car (gimp-image-pick-color img calque_fond 10 10 FALSE FALSE 0)) ; color	 The color to set
							(round (+ 10 (random 90))) ; opacity
				)
	)


	
	
;*******************************************************************************************


	; remplir de blanc
	(gimp-drawable-fill calque_fond 2)

	; appliquer un dgrad sur calque_fond
	(gimp-edit-blend 
					calque_fond ; drawable
					3 ; blend-mode		CUSTOM-MODE (3) 
					0 ; paint-mode
					9 ; gradient-type		  GRADIENT-SPIRAL-CLOCKWISE (9)
					100 ; opacity
					0 ; offset
					0 ; repeat
					FALSE ; reverse
					TRUE ; supersample
					3 ; max-depth
					0.2 ; threshold
					FALSE ; dither
					200 ; x1 
					200 ; y1 
					400 ; x2
					400 ; y2
	)	

;*******************************************************************************************
	
	; restaurer PP et AP
	(gimp-context-set-foreground  old-fg)
	(gimp-context-set-background old-bg)

	; dtruire le dgrad cr pour ce script
	;(gimp-gradient-delete gradient_name)
	
	; restaurer ancien dgrad
	;(gimp-context-set-gradient old_gradient)
    
	; ne rien slectionner
	(gimp-selection-none img)
	
	; afficher l'image
	(gimp-display-new img)

	;; End undo group.
	(gimp-image-undo-group-end img)	

	)
		
)



(script-fu-register
	"gradient_generator_1_or_2_colors"
	"<Image>/File/Create/Gradients/Gradient generator 1-2 colors..."
	"Generateur de degrade 1 ou 2 couleurs / Gradient generator 1 or 2 colors (2-1024 segments)"
	"samj"
	"samj"
	"2010-12-20"
	""
	SF-ADJUSTMENT "Nb segments"  '(32 2 1024 1 10 0 1) ; Nombre de segments
	SF-STRING "Nom du degrade / Gradient name" "Gradient 1-2 colors"
	SF-COLOR "Couleur / Color" '(206 50 206) ; '(184 32 16) '(255 255 0)
	SF-TOGGLE "Clair / Clear" FALSE
	SF-TOGGLE "Couleur complementaire / Complementary color" FALSE

)


; FIN du script