; Dbut du script-fu misticheskaya_vudu_tekstura_gimp_2_8.scm
;
; Accs par :   Fichier > Crer > Motifs > Misticheskaya Vudu Tekstura...
;               File > Create > Patterns > Misticheskaya Vudu Tekstura...
;
;                __________________________________________________________
; 
;
; script-fu adapt du didacticiel  http://www.progimp.ru/articles/misticheskaya_vudu-tekstura/
; Merci  l'auteur.
;
; 
;
; Licence GNU/GPL
;
; --------------------------------------------------------------------
; dit avec Notepad++    http://notepad-plus-plus.org/
;
; version 1.0 par samj (  http://www.aljacom.com/~gimp       http://samjcreations.blogspot.com  ) 5 juin 2012
;
; --------------------------------------------------------------------
;
;


(define (
				misticheskaya_vudu_tekstura
				width
				height
				taille
				saturation
				couleur
				tileable
		)
		
	(let*
		(
			; affectation des variables		
	
			; mmoriser les couleurs PP et AP
			(old-fg (car (gimp-context-get-foreground)))
			(old-bg (car (gimp-context-get-background)))
			
			; crer une nouvelle image rgb
			(img (car (gimp-image-new width height 0)))
			
			;calque_fond
			(calque_fond)

			;calque_couleur)
			(calque_couleur)

			;calque_couleur2)
			(calque_couleur2)		
		
		)

	;; Start undo group.
	(gimp-image-undo-group-start img)		
		

		
		

; calque_fond*********************************************************************************
	


	; crer calque_fond
	(set! calque_fond (car (gimp-layer-new img width height 1 "calque_fond" 100 0)))	
	
	; ajouter le calque calque_fond
	(gimp-image-insert-layer img calque_fond 0 -1)
	
	; remplir de blanc
	(gimp-drawable-fill calque_fond 2)

	; cubisme
	(plug-in-cubism 
		1					; run-mode 
		img					; image 
		calque_fond			; drawable 
		taille				; tile-size 
		saturation			; tile-saturation 
		0					; bg-color
	)

	
	; flou
	(plug-in-gauss 
		1					; run-mode 
		img					; image 
		calque_fond			; drawable 
		2					; horizontal 
		2					; vertical 
		0					; method
	)

	
	; contour
	(plug-in-edge 
		1						; run-mode 
		img						; image 
		calque_fond				; drawable 
		2.0						; amount 
		2						; wrapmode 
		0						; edgemode
	)


	; rendre le motif raccordable
	(if	
		(= tileable TRUE) 
			; appel du greffon 
			(plug-in-make-seamless 1 img  calque_fond)
	)	


	
;*******************************************************************************************	
	
	; modifier couleur de premier plan
	(gimp-context-set-foreground couleur)	
	
	
; calque_couleur*********************************************************************************

	; crer calque_couleur
	(set! calque_couleur (car (gimp-layer-new img width height 1 "calque_couleur" 100 0)))

	; ajouter le calque calque_couleur
	(gimp-image-insert-layer img calque_couleur 0 -1)
	
	; remplir de PP	
	(gimp-drawable-fill calque_couleur 0)

	; mode couleur
	(gimp-layer-set-mode calque_couleur 13)
	
; calque_couleur2*********************************************************************************

	; crer calque_couleur2
	(set! calque_couleur2 (car (gimp-layer-new img width height 1 "calque_couleur2" 100 0)))

	; ajouter le calque calque_couleur2
	(gimp-image-insert-layer img calque_couleur2 0 -1)

	; remplir de PP	
	(gimp-drawable-fill calque_couleur2 0)	

	; mode cran
	(gimp-layer-set-mode calque_couleur2 4)

	; opacit  50%
	(gimp-layer-set-opacity calque_couleur2 50)


;*******************************************************************************************	
	
	; aplatir
	(gimp-image-flatten img)
	
	
;*******************************************************************************************
	
	; restaurer PP et AP
	(gimp-context-set-foreground  old-fg)
	(gimp-context-set-background old-bg)

	; ne rien slectionner
	(gimp-selection-none img)
	
	; afficher l'image
	(gimp-display-new img)

	; End undo group.
	(gimp-image-undo-group-end img)	

	)
		
)



(script-fu-register
	"misticheskaya_vudu_tekstura"
	"<Image>/File/Create/Patterns/Misticheskaya Vudu Tekstura..."
	"Motif Misticheskaya Misticheskaya Vudu"
	"samj"
	"samj"
	"2010-06-05"
	""
	SF-ADJUSTMENT "Largeur motif / Width (pixels)"  '(500 64 4096 8 64 0 1) ; pixels
	SF-ADJUSTMENT "Hauteur motif / Height (pixels)"  '(500 64 4096 8 64 0 1) ; pixels
	SF-ADJUSTMENT "Taille des carreaux / Diameter of each tile"  '(17 8 100 1 10 0 1) ; taille des carreaux	
	SF-ADJUSTMENT "Saturation"  '(2.2 0.8 2.5 0.1 1 1 1) ; saturation des carreaux
	SF-COLOR "Couleur" '(140 27 27)
	SF-TOGGLE	"Rendre raccordable / Tileable" FALSE
)


; FIN du script