; Script-Fu script_fu_fitshape_gmic.scm
; Download : 
;
;	Copyright (C) 2013 samj ( http://aljacom.com/~gmic/ )
;
;	Licence GPL
;		Ce fichier est le Script-Fu "script_fu_fitshape_gmic.scm" pour Gimp. 
;		Ce Script-Fu "script_fu_fitshape_gmic.scm" est un logiciel libre ; vous pouvez le redistribuer ou le modifier suivant les termes de la GNU General Public License
;		telle que publie par la Free Software Foundation ; soit la version 3 de la licence, soit ( votre gr) toute version ultrieure.
;		Ce Script-Fu "script_fu_fitshape_gmic.scm" est distribu dans l'espoir qu'il sera utile, mais SANS AUCUNE GARANTIE ; 
;		pas mme la garantie implicite de COMMERCIABILISABILIT ni d'ADQUATION  UN OBJECTIF PARTICULIER.
;		Consultez la GNU General Public License pour plus de dtails.
;		Vous devez avoir reu une copie de la GNU General Public License en mme temps que GIMP ; si ce n'est pas le cas, consultez <http://www.gnu.org/licenses>
;
;	Ce fichier script_fu_fitshape_gmic.scm est dit avec Notepad++    http://notepad-plus-plus.org/
;
;
;	Version 20130612 (origine)
;
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;
;
;
;	Accs sur l'image par :
;
;	Filtres > Script-Fu FitShape GMIC ...
;	Filters > Script-Fu FitShape GMIC ...
;
;
;
;
;	Origine :
;				- Ce script-fu est une adaptation d'un autre script utilis pour crer des images  crayonner pour les enfants.
;
;
;	Principes :
;				- L'utilisation des images  couleurs indexes permet d'obtenir des zones uniformes de couleurs.
;				- La transformation en niveaux de gris permet de slectionner rapidement ces zones uniformes, de les transformer en masques pour G'MIC.
;
;	Utilisation
;				- Utiliser des images bien contrastes, ventuellement augmenter les contrastes avec Gimp.
;				- L'option "Rounded Lines (blur)" permet d'avoir des contours arrondis.
;				- L'option "Soften" permet d'arrondir les pointes.
;
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;
;

		
(define	
	(
		Script-Fu_FitShape_GMIC_samj
		image
		drawable
		Pretreatments
		Rounded_Lines
		Soften
		Nb_Layers_Calques
		Back_Ground_Color



		
	)
	(let* 
		(

			(message (car (gimp-message-get-handler)))


			(width (car (gimp-image-width image)))
			(height (car (gimp-image-height image)))

			(transparence (car (gimp-drawable-has-alpha drawable)))

			(selection_en_cours)
			(nouvelle_image)
			(calque_copie)
			(copier_visible)
			(buffer-name "copier_visible")
			(rvb 0)
			(selection_bounds 0)
			(select_exist 0)
			(select_offset_x 0)
			(select_offset_y 0)
			(select_width 0)
			(select_height 0)
			(sortie_boucle 0)


			(matrix 0)
			(matrix-list 0)
			(channels 0)
			
			(masque_1)
			(masque_2)
			(masque_3)
			(masque_4)
			(masque_5)
			(masque_6)
			(masque_7)
			(masque_8)
			(masque_9)
			(masque_10)
			(masque_11)
			(masque_12)
			(masque_13)
			(masque_14)
			(masque_15)
			(masque_16)
			(Nb_masque 0)
			(resultat)
			(motif)


		)


		; pour image existante
		(gimp-undo-push-group-start image) 
		
		;; Start undo. Recommand par Saulgoode pour nouvelle image http://gimpchat.com/viewtopic.php?f=9&t=7342#p93780
		; (gimp-image-undo-disable image)

		; sauvegard le contexte.  Recommand par Saulgoode http://gimpchat.com/viewtopic.php?f=9&t=7342#p93780
		(gimp-context-push)

		;; slectionner la console erreurs pour envoyer un message
		(gimp-message-set-handler 2)

		(gimp-selection-none image)



		(gimp-context-set-antialias FALSE)
		(gimp-context-set-feather FALSE)
		(gimp-context-set-feather-radius 0 0)
		(gimp-context-set-sample-merged FALSE)
		(gimp-context-set-sample-criterion 0)
		(gimp-context-set-sample-threshold 0)
		(gimp-context-set-sample-transparent FALSE)

		(gimp-context-set-transform-direction TRANSFORM-FORWARD)
		(gimp-context-set-interpolation 2)
		(gimp-context-set-transform-recursion 3)
		(gimp-context-set-transform-resize TRANSFORM-RESIZE-ADJUST)
		
		(gimp-context-set-paint-mode 0) ;

;******************************************************************************************************
; 
;******************************************************************************************************


		(set! copier_visible (car (gimp-edit-named-copy-visible image buffer-name)))

		; crer une nouvelle image rgb
		(set! nouvelle_image (car (gimp-image-new width height 0)))

		;; Start undo. Recommand par Saulgoode pour nouvelle image http://gimpchat.com/viewtopic.php?f=9&t=7342#p93780
		(gimp-image-undo-disable nouvelle_image)


		; crer le premier calque
		(set! calque_copie (car (gimp-layer-new nouvelle_image width height 0 "calque_gris" 100 0)))

		(gimp-image-insert-layer nouvelle_image calque_copie -1 0)

		(gimp-image-select-rectangle nouvelle_image 0  width height 0 0 )

		(set! selection_en_cours (car (gimp-edit-named-paste calque_copie copier_visible 0)))

		(gimp-floating-sel-anchor selection_en_cours)

		(gimp-selection-none nouvelle_image)

		(gimp-layer-add-alpha calque_copie)

		(gimp-levels-stretch calque_copie)
		(gimp-equalize calque_copie TRUE)

		; ajuster taille image  la taille des calques
		(gimp-image-resize-to-layers nouvelle_image)

		(set! calque_copie (car (gimp-image-get-active-layer nouvelle_image)))


		(if (or (= Pretreatments 1) (= Pretreatments 3) ) ; "B For dark images"
			(begin

				(set! matrix-list
					'(
						0		0		0		0		0
						0		1		0		0		0
						0		0		1		0		0
						0		0		0		0		0
						0		0		0		0		0
					 )
				)

				(set! channels (make-vector 5 'long ))

				(vector-set! channels 0 1 )
				(vector-set! channels 1 1 )
				(vector-set! channels 2 1 )
				(vector-set! channels 3 1 )
				(vector-set! channels 4 1 )

				; Convert maxtrix list (25) into matrix array (5x5)
				(define (get-matrix matrix-list)
				  (let* (
						(n 0)
						)
				  (set! n 25 )
				  (define (list-ref l n) (nth n l))
					(let* ((count 0)
						   (matrix (cons-array 25 'double)))
					  (while (< count 25 )
					  (aset matrix count (list-ref matrix-list count))
					  (set! count (+ count 1)))
					  matrix ; Return the matrix array
					)
				  )
				)

				; (plug-in-convmatrix run-mode image drawable argc-matrix matrix alpha-alg divisor offset argc-channels channels bmode)
				(plug-in-convmatrix 1 nouvelle_image calque_copie 25 (set! matrix (get-matrix matrix-list)) 1 1 0 5 channels 0)


			)
		)


		(if (or (= Pretreatments 2) (= Pretreatments 3) ) ; "C Low contrast picture"
			(begin


				(set! matrix-list
					'(
						-1		0		0		0		0
						0		1		0		0		0
						0		0		1		0		0
						0		0		0		0		0
						0		0		0		0		0
					 )
				)

				(set! channels (make-vector 5 'long ))

				(vector-set! channels 0 1 )
				(vector-set! channels 1 1 )
				(vector-set! channels 2 1 )
				(vector-set! channels 3 1 )
				(vector-set! channels 4 1 )

				; Convert maxtrix list (25) into matrix array (5x5)
				(define (get-matrix matrix-list)
				  (let* (
						(n 0)
						)
				  (set! n 25 )
				  (define (list-ref l n) (nth n l))
					(let* ((count 0)
						   (matrix (cons-array 25 'double)))
					  (while (< count 25 )
					  (aset matrix count (list-ref matrix-list count))
					  (set! count (+ count 1)))
					  matrix ; Return the matrix array
					)
				  )
				)

				; (plug-in-convmatrix run-mode image drawable argc-matrix matrix alpha-alg divisor offset argc-channels channels bmode)
				(plug-in-convmatrix 1 nouvelle_image calque_copie 25 (set! matrix (get-matrix matrix-list)) 1 1 0 5 channels 0)



			)
		)

		(gimp-desaturate-full calque_copie 1)

		(gimp-posterize calque_copie Nb_Layers_Calques)

		(if (> Rounded_Lines 0) 
			;;;;;(plug-in-gauss 1 nouvelle_image calque_copie (round (+ 1 (/ width 40)))  (round (+ 1 (/ height 40)))   1)
			(plug-in-gauss 1 nouvelle_image calque_copie Rounded_Lines  Rounded_Lines   1)
		)

		(gimp-convert-indexed nouvelle_image 0 0 Nb_Layers_Calques 1 1 "")

		(gimp-image-convert-grayscale nouvelle_image)

		(gimp-image-convert-rgb nouvelle_image)





		;******************************************************************************************************
		; crer les calques utiliss comme masques
		;******************************************************************************************************

		(gimp-context-set-background '(0 0 0))
		(gimp-context-set-foreground '(255 255 255))

		(set! sortie_boucle 0)
		(set! rvb -1)

		; boucle pour trouver les couleurs, faire une slection par couleur , crer les masques
		(while
			(= sortie_boucle 0)
				(begin

					(set! rvb (+ rvb 1) )
					(if (= rvb 256)
						(begin
							(set! sortie_boucle 1 )
						)
					)

					(gimp-selection-none nouvelle_image)

					(if (= sortie_boucle 0)
						(begin

							(gimp-image-select-color nouvelle_image 0 calque_copie (list rvb rvb rvb))
							(gimp-selection-feather nouvelle_image 0)

							(set! selection_bounds (gimp-selection-bounds nouvelle_image))
							(set! select_exist (car selection_bounds))
							;(set! select_offset_x (cadr selection_bounds))
							;(set! select_offset_y (caddr selection_bounds))
							;(set! select_width (- (cadr (cddr selection_bounds)) select_offset_x))
							;(set! select_height (- (caddr (cddr selection_bounds)) select_offset_y))
							;(gimp-message (number->string select_exist))

							(if (= select_exist 1)
								(begin

									(if (> Soften 0)
										(begin
											(gimp-selection-grow nouvelle_image Soften)
											(gimp-selection-shrink nouvelle_image Soften)
										)
									)

									(set! Nb_masque (+ Nb_masque 1) )

									(if (> Nb_masque Nb_Layers_Calques)
										(begin
											(set! sortie_boucle 1 )
										)
										;else
										(begin

											; (gimp-message (number->string Nb_masque) )

											(if (= Nb_masque 1)
												(begin
													(set! masque_1 (car (gimp-layer-new nouvelle_image width height 0 "masque_1" 100 0)))
													(gimp-image-insert-layer nouvelle_image masque_1 -1 0)
													(gimp-drawable-fill masque_1 2) ; white
													(gimp-edit-fill masque_1 1) ; background
													(gimp-item-set-visible masque_1 TRUE)
													; (gimp-message (number->string rvb) )
												)
											)

											(if (= Nb_masque 2)
												(begin
													(set! masque_2 (car (gimp-layer-new nouvelle_image width height 0 "masque_2" 100 0)))
													(gimp-image-insert-layer nouvelle_image masque_2 -1 0)
													(gimp-drawable-fill masque_2 2) ; white
													(gimp-edit-fill masque_2 1) ; background
													(gimp-item-set-visible masque_2 TRUE)
													; (gimp-message (number->string rvb) )
												)
											)

											(if (= Nb_masque 3)
												(begin
													(set! masque_3 (car (gimp-layer-new nouvelle_image width height 0 "masque_3" 100 0)))
													(gimp-image-insert-layer nouvelle_image masque_3 -1 0)
													(gimp-drawable-fill masque_3 2) ; white
													(gimp-edit-fill masque_3 1) ; background
													(gimp-item-set-visible masque_3 TRUE)
													; (gimp-message (number->string rvb) )
												)
											)

											(if (= Nb_masque 4)
												(begin
													(set! masque_4 (car (gimp-layer-new nouvelle_image width height 0 "masque_4" 100 0)))
													(gimp-image-insert-layer nouvelle_image masque_4 -1 0)
													(gimp-drawable-fill masque_4 2) ; white
													(gimp-edit-fill masque_4 1) ; background
													(gimp-item-set-visible masque_4 TRUE)
													; (gimp-message (number->string rvb) )
												)
											)

											(if (= Nb_masque 5)
												(begin
													(set! masque_5 (car (gimp-layer-new nouvelle_image width height 0 "masque_5" 100 0)))
													(gimp-image-insert-layer nouvelle_image masque_5 -1 0)
													(gimp-drawable-fill masque_5 2) ; white
													(gimp-edit-fill masque_5 1) ; background
													(gimp-item-set-visible masque_5 TRUE)
													; (gimp-message (number->string rvb) )
												)
											)

											(if (= Nb_masque 6)
												(begin
													(set! masque_6 (car (gimp-layer-new nouvelle_image width height 0 "masque_6" 100 0)))
													(gimp-image-insert-layer nouvelle_image masque_6 -1 0)
													(gimp-drawable-fill masque_6 2) ; white
													(gimp-edit-fill masque_6 1) ; background
													(gimp-item-set-visible masque_6 TRUE)
													; (gimp-message (number->string rvb) )
												)
											)

											(if (= Nb_masque 7)
												(begin
													(set! masque_7 (car (gimp-layer-new nouvelle_image width height 0 "masque_7" 100 0)))
													(gimp-image-insert-layer nouvelle_image masque_7 -1 0)
													(gimp-drawable-fill masque_7 2) ; white
													(gimp-edit-fill masque_7 1) ; background
													(gimp-item-set-visible masque_7 TRUE)
													; (gimp-message (number->string rvb) )
												)
											)

											(if (= Nb_masque 8)
												(begin
													(set! masque_8 (car (gimp-layer-new nouvelle_image width height 0 "masque_8" 100 0)))
													(gimp-image-insert-layer nouvelle_image masque_8 -1 0)
													(gimp-drawable-fill masque_8 2) ; white
													(gimp-edit-fill masque_8 1) ; background
													(gimp-item-set-visible masque_8 TRUE)
													; (gimp-message (number->string rvb) )
												)
											)

											(if (= Nb_masque 9)
												(begin
													(set! masque_9 (car (gimp-layer-new nouvelle_image width height 0 "masque_9" 100 0)))
													(gimp-image-insert-layer nouvelle_image masque_9 -1 0)
													(gimp-drawable-fill masque_9 2) ; white
													(gimp-edit-fill masque_9 1) ; background
													(gimp-item-set-visible masque_9 TRUE)
													; (gimp-message (number->string rvb) )
												)
											)

											(if (= Nb_masque 10)
												(begin
													(set! masque_10 (car (gimp-layer-new nouvelle_image width height 0 "masque_10" 100 0)))
													(gimp-image-insert-layer nouvelle_image masque_10 -1 0)
													(gimp-drawable-fill masque_10 2) ; white
													(gimp-edit-fill masque_10 1) ; background
													(gimp-item-set-visible masque_10 TRUE)
													; (gimp-message (number->string rvb) )
												)
											)

											(if (= Nb_masque 11)
												(begin
													(set! masque_11 (car (gimp-layer-new nouvelle_image width height 0 "masque_11" 100 0)))
													(gimp-image-insert-layer nouvelle_image masque_11 -1 0)
													(gimp-drawable-fill masque_11 2) ; white
													(gimp-edit-fill masque_11 1) ; background
													(gimp-item-set-visible masque_11 TRUE)
													; (gimp-message (number->string rvb) )
												)
											)

											(if (= Nb_masque 12)
												(begin
													(set! masque_12 (car (gimp-layer-new nouvelle_image width height 0 "masque_12" 100 0)))
													(gimp-image-insert-layer nouvelle_image masque_12 -1 0)
													(gimp-drawable-fill masque_12 2) ; white
													(gimp-edit-fill masque_12 1) ; background
													(gimp-item-set-visible masque_12 TRUE)
													; (gimp-message (number->string rvb) )
												)
											)

											(if (= Nb_masque 13)
												(begin
													(set! masque_13 (car (gimp-layer-new nouvelle_image width height 0 "masque_13" 100 0)))
													(gimp-image-insert-layer nouvelle_image masque_13 -1 0)
													(gimp-drawable-fill masque_13 2) ; white
													(gimp-edit-fill masque_13 1) ; background
													(gimp-item-set-visible masque_13 TRUE)
													; (gimp-message (number->string rvb) )
												)
											)

											(if (= Nb_masque 14)
												(begin
													(set! masque_14 (car (gimp-layer-new nouvelle_image width height 0 "masque_14" 100 0)))
													(gimp-image-insert-layer nouvelle_image masque_14 -1 0)
													(gimp-drawable-fill masque_14 2) ; white
													(gimp-edit-fill masque_14 1) ; background
													(gimp-item-set-visible masque_14 TRUE)
													; (gimp-message (number->string rvb) )
												)
											)

											(if (= Nb_masque 15)
												(begin
													(set! masque_15 (car (gimp-layer-new nouvelle_image width height 0 "masque_15" 100 0)))
													(gimp-image-insert-layer nouvelle_image masque_15 -1 0)
													(gimp-drawable-fill masque_15 2) ; white
													(gimp-edit-fill masque_15 1) ; background
													(gimp-item-set-visible masque_15 TRUE)
													; (gimp-message (number->string rvb) )
												)
											)

											(if (= Nb_masque 16)
												(begin
													(set! masque_16 (car (gimp-layer-new nouvelle_image width height 0 "masque_16" 100 0)))
													(gimp-image-insert-layer nouvelle_image masque_16 -1 0)
													(gimp-drawable-fill masque_16 2) ; white
													(gimp-edit-fill masque_16 1) ; background
													(gimp-item-set-visible masque_16 TRUE)
													; (gimp-message (number->string rvb) )
												)
											)

											(gimp-selection-none nouvelle_image)

										)
									)




								)
							)




						
						)
					)



				)
		)





		;******************************************************************************************************
		; appel de G'MIC 
		;******************************************************************************************************


		(gimp-context-set-background '(0 0 0))
		(gimp-context-set-background '(255 127 0))
		(set! motif (car (gimp-layer-new nouvelle_image 16 16 0 "motif" 100 0)))
		(gimp-image-insert-layer nouvelle_image motif -1 0)
		(gimp-drawable-fill motif 1) ; background
		(gimp-item-set-visible motif TRUE)


		(gimp-context-set-background Back_Ground_Color)
		(set! resultat (car (gimp-layer-new nouvelle_image width height 0 "resultat" 100 0)))
		(gimp-image-insert-layer nouvelle_image resultat -1 0)
		(gimp-drawable-fill resultat 1) ; background
		(gimp-item-set-visible resultat TRUE)


		(set! sortie_boucle 0)
		(set! Nb_masque 0 )

		; boucle pour appliquer les masques , les motifs su le calque rsultat
		(while
			(= sortie_boucle 0)
				(begin

					(set! Nb_masque (+ Nb_masque 1) )

					(if (> Nb_masque Nb_Layers_Calques)
						(begin
							(set! sortie_boucle 1 )
						)
						;else
						(begin








						)
					)



				)
		)




						; G'MIC Painting : gimp_painting
;						(plug-in-gmic 1 nouvelle_image masque_1 3
;							(string-append
;								"-v - " ; To have a silent output. Remove it to display errors from the G'MIC interpreter on stderr.
;								"-blur 30"
;							)
;						)	












		(gimp-selection-none nouvelle_image)













;******************************************************************************************************
; 
;******************************************************************************************************



		(gimp-display-new nouvelle_image)

		; End undo. Recommand par Saulgoode pour nouvelle image http://gimpchat.com/viewtopic.php?f=9&t=7342#p93780
		(gimp-image-undo-enable nouvelle_image)




;******************************************************************************************************
; 
;******************************************************************************************************

		;; rtablir le mode message
		(gimp-message-set-handler message)

		; restituer l'ancien contexte.  Recommand par Saulgoode http://gimpchat.com/viewtopic.php?f=9&t=7342#p93780
		(gimp-context-pop)

		; End undo. Recommand par Saulgoode pour nouvelle image http://gimpchat.com/viewtopic.php?f=9&t=7342#p93780
		;(gimp-image-undo-enable image)

		; pour image existante
		(gimp-undo-push-group-end image)

		(gimp-displays-flush)


	)
)



; Nouvelle mthode recommand par Saulgoode http://gimpchat.com/viewtopic.php?f=9&t=7342#p93780
(script-fu-register "Script-Fu_FitShape_GMIC_samj"
                    _"Script-Fu FitShape GMIC ..."
                    "Script-Fu FitShape GMIC ..."
                    "samj"
                    "samj"
                    "20130612"
                    "RGB*"
                    SF-IMAGE    "Image"     0
                    SF-DRAWABLE "Drawable"  0
					SF-OPTION "Pretreatments " '("A  Without" "B  For dark images" "C  Low contrast picture" "  B + C  ")
					SF-ADJUSTMENT "Rounded Lines (blur) " '(0 0 60 1 5 0 1)
					SF-ADJUSTMENT "Soften " '(2 0 60 1 5 0 1)
					SF-ADJUSTMENT "Nb Layers / Calques " '(8 2 16 1 5 0 1)
					SF-COLOR "Back Ground Color " '(255 255 255)




)

; Nouvelle mthode recommand par Saulgoode http://gimpchat.com/viewtopic.php?f=9&t=7342#p93780
(script-fu-menu-register "Script-Fu_FitShape_GMIC_samj"
					_"<Image>/Filters"
)



;; FIN





