; Script-Fu  texture_002.scm
;
;
;	Copyright (C) 2013 samj ( http://www.aljacom.com/ )
;
;	Licence GPL
;		Ce fichier est le Script-Fu "texture_002.scm" pour Gimp. 
;		Ce Script-Fu "texture_002.scm" est un logiciel libre ; vous pouvez le redistribuer ou le modifier suivant les termes de la GNU General Public License
;		telle que publie par la Free Software Foundation ; soit la version 3 de la licence, soit ( votre gr) toute version ultrieure.
;		Ce Script-Fu "texture_002.scm" est distribu dans l'espoir qu'il sera utile, mais SANS AUCUNE GARANTIE ; 
;		pas mme la garantie implicite de COMMERCIABILISABILIT ni d'ADQUATION  UN OBJECTIF PARTICULIER.
;		Consultez la GNU General Public License pour plus de dtails.
;		Vous devez avoir reu une copie de la GNU General Public License en mme temps que GIMP ; si ce n'est pas le cas, consultez <http://www.gnu.org/licenses>
;
;	Ce fichier texture_002.scm est dit avec Notepad++    http://notepad-plus-plus.org/
;
;
;
;
;
;	Didacticiel / Tutorial  http://en.wikibooks.org/wiki/GIMP/Create_a_Stone_Texture
;
;	Version 1 20131206
;
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;
;
;
;	Accs sur l'image par :
;	Filtres > Texture 002 ...
;
;	Access on the image by :
;	Filters > Texture 002 ...
;
;	http://gimpchat.com/viewtopic.php?f=4&t=9175
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;
;
;


(define	
	(
		texture_002_samj
		image
		drawable
		Intensity
		Boost
		Automatic


	)
	(let* 
		(
			;; variables utiles
			(message (car (gimp-message-get-handler)))
			(width (car (gimp-image-width image)))
			(height (car (gimp-image-height image)))
			(transparence (car (gimp-drawable-has-alpha drawable)))

			(calque_Solid_Noise)
			(calque_Plasma)
			(calque_Texture)
			(calque_Result)

		)





		; pour image existante
		(gimp-undo-push-group-start image) 

		; sauvegard le contexte.  Recommand par Saulgoode http://gimpchat.com/viewtopic.php?f=9&t=7342#p93780
		(gimp-context-push)

		;; slectionner la console erreurs pour envoyer un message
		(gimp-message-set-handler 2)		


;******************************************************************************************************
; 
;******************************************************************************************************



		; Solid Noise
		(set! calque_Solid_Noise (car (gimp-layer-new image width height 1 "Solid Noise" 100 0)))
		(gimp-image-insert-layer image calque_Solid_Noise -1 0)
		(plug-in-solid-noise 1 image calque_Solid_Noise 0 0 (round (random 54321)) 1 4 4)
		(plug-in-gauss-rle2 1 image calque_Solid_Noise (round (/ (+ width height) 7)) (round (/ (+ width height) 7)))


		; Plasma
		(set! calque_Plasma (car (gimp-layer-new image width height 1 "Plasma" 100 0)))
		(gimp-image-insert-layer image calque_Plasma -1 0)
		(plug-in-plasma 1 image calque_Plasma (round (random 54321)) (random 10))



		; Texture
		(set! calque_Texture (car (gimp-layer-new-from-drawable calque_Solid_Noise image)))
		(gimp-image-insert-layer image calque_Texture -1 0)
		(gimp-item-set-name calque_Texture "Texture")
		(plug-in-bump-map 1 image calque_Texture calque_Plasma 135 45 20 0 0 0 0 1 0 2)
		(if (= Boost TRUE)
				(gimp-levels-stretch calque_Texture)
		)


		; Result
		(set! calque_Result (car (gimp-layer-new-from-drawable drawable image)))
		(gimp-image-insert-layer image calque_Result -1 0)
		(gimp-item-set-name calque_Result "Result")
		(plug-in-bump-map Automatic image calque_Result calque_Texture 135 45 Intensity 0 0 0 0 1 0 2)













;******************************************************************************************************
; 
;******************************************************************************************************

		;; rtablir le mode message
		(gimp-message-set-handler message)

		; restituer l'ancien contexte.
		(gimp-context-pop)

		; pour image existante
		(gimp-undo-push-group-end image)

		(gimp-displays-flush)

	)
)



(script-fu-register "texture_002_samj"
                    _"<Image>/Filters/Texture 002 ..."
                    "Tests textures"
                    "samj"
                    "samj"
                    "20131205"
                    "RGB*"
                    SF-IMAGE    "Image"     0
                    SF-DRAWABLE "Drawable"  0
					SF-ADJUSTMENT "Intensity " '(3 1 10 1 5 0 1)
					SF-TOGGLE "Boost " FALSE
					SF-TOGGLE "Automatic " TRUE


)






;; FIN





